
/// <reference path="../../main.js"/>

/// <summary>Input helper</summary>

// ------------------------------------------------------

var ime = null;
var inputString = "";
var timerallowInputs = null;
var timerSliderMoves = null;
var imeCreated = false;
var imeVisible = false;

var elementIds = ["dummy-input", "LoginInputName", "LoginInputPassword"];
var inputs = [null];
var ready = [false];

// -------------------------------------------------------
Input = {

    allowInput: null,
    allowSliderMove: null,
    inputString: ""

}

// ------------------------------------------------------
var Input = function (id) {
  /// <summary>Input class. Set input callbacks.</summary>

  var imeReady = function (imeObject) {
    installFocusKeyCallbacks();
    installStatusCallbacks();
    Input.inputReady(id);
  }

  var ime = new IMEShell(id, imeReady, 'en');

  var element = document.getElementById(id);

  // ---------------------------------------------------------------
  var installFocusKeyCallbacks = function () {
    /// <summary>Install focus callbacks.</summary>
    ime.setKeyFunc(tvKey.KEY_UP, function (keyCode) { onUp(); return false; });
    ime.setKeyFunc(tvKey.KEY_DOWN, function (keyCode) { onDown(); return false; });
    // ime.setKeyFunc(tvKey.KEY_LEFT, function (keyCode) { onLeft(); return false; });
    //ime.setKeyFunc(tvKey.KEY_RIGHT, function (keyCode) { onRight(); return false; });
    ime.setKeyFunc(tvKey.KEY_RETURN, function (keyCode) { Key.keyPress(); return false; });
    ime.setKeyFunc(tvKey.KEY_EXIT, function (keyCode) {
      Player.Stop();
      widgetAPI.sendExitEvent();
      return false;
    });
    ime.setKeyFunc(tvKey.KEY_TOOLS, function (keyCode) {

      if (!imeVisible)
        return false;
    });

    

  }

  // --------------------------------------------------------
  var installStatusCallbacks = function () {
    /// <summary>Install status callbacks.</summary>

    ime.setKeypadPos(Main.setting.Input.PosX, Main.setting.Input.PosY);
    ime.setWordBoxPos(18, 6);
    ime.setAnyKeyFunc(onAnyKey);
    ime.setMaxLengthFunc(onMaxLength);
    ime.setPrevEventOnLeftFunc(onLeft);
    ime.setOnCompleteFunc(onComplete);
    ime.setEnterFunc(onEnter);
    ime.setKeyFunc(tvKey.KEY_INFO, onInfoKey);
    ime.setKeyFunc(tvKey.KEY_TOOLS, onToolsKey);
  }

  // ---------------------------------------------------------
  var onAnyKey = function (keyCode) {
    /// <summary>Any key event.</summary>


      if (keyCode == "QWERTY") {
          setTimeout(function () {
              _g_ime.is_keyboardMode = false;
          }, 300);
      }


    // Key tools
    if (keyCode == 75 && !imeVisible)
      return;

    if (!imeVisible) {
        //Log.write(" =========== keyCode");
      Key.keyPress();
    } else {
      //Log.write($("#ime_keypad").html());
      //Log.write(" ime not visible");
    }

  }

  // ------------------------------------------------------
  var onMaxLength = function () {
    /// <summary>Input text reach maximum length</summary>
    //Log.write("Maximum length of input reached in " + element.id + ", text is " + element.value);
  }

  // ----------------------------------------------
  var onUp = function () {
    /// <summary>Key event 'up'</summary>

    Key.keyPress();
  }

  // ----------------------------------------------
  var onDown = function () {
    /// <summary>Key event 'down'</summary>
    Key.keyPress();
  }

  // ------------------------------------------------
  var onLeft = function () {
    /// <summary>Key event 'left'</summary>
    if (!imeVisible) {
      //ime.setString(inputString);
      //Key.keyPress();
    }

  }

  // ------------------------------------------------
  var onRight = function () {
    /// <summary>Key event 'right'</summary>
    if (!imeVisible) {
      //ime.setString(inputString);
      //Key.keyPress();
    }

  }

  // --------------------------------------------------
  var onComplete = function () {
    /// <summary>Complete event.</summary>
  }

  // ------------------------------------------------
  var onEnter = function (string) {
    /// <summary>Key event 'enter'.</summary>

    string = new String(string);
    string = string.trim();

    inputString = string;

    $('body').trigger('inputEntrerKeyEvent', string);

  }

  // ---------------------------------------------
  var onInfoKey = function (keyCode) {
    /// <summary>Key event 'info key'</summary>

    return true;
  }

  // ---------------------------------------------
  var onToolsKey = function (keyCode) {
    /// <summary>Key event 'tools key'</summary>

    //return false;

    if (imeVisible) {
      return true;
    }
    else
      return false;

  };

}

// -----------------------------------------------------
Input.allowInputs = function () {
    /// <summary>Input is allowed after period.</summary>

    this.allowInput = true;
    clearTimeout(timerallowInputs);

};

// -----------------------------------------------------
Input.allowSliderMoves = function () {

    this.allowSliderMove = true;
    clearTimeout(timerSliderMoves);

};

// -----------------------------------------------------
Input.createInputObjects = function () {
  /// <summary>Register input fields.</summary>


  imeCreated = true;


  for (var i = 0; i < elementIds.length; i++) {
    inputs[i] = new Input(elementIds[i]);
  }

}

// -----------------------------------------------------
Input.inputReady = function (id) {
    /// <summary>Set start up focus to the dummy element.</summary>
  document.getElementById("dummy-input").focus();
};

// -----------------------------------------------------

Input.showInput = function () {
  /// <summary>Show on-screen keybord.</summary>

  //Main.log("Input.showInput");

  $("#ime_keypad").css("left", Main.setting.Input.PosX + "px");
  $("#ime_keypad").css("top", Main.setting.Input.PosY + "px");
  $("#ime_keypad").css("z-index", "100");

  $("#ime_wordselect").show();
  $("#ime_keypad").show();
  $("#ime_help_bar").show();

  imeVisible = true;

};

// -----------------------------------------------------

Input.hideInput = function () {
  /// <summary>Hide on-screen keybord.</summary>

    $("#ime_keypad").hide();
    $("#ime_wordselect").hide();
    $("#ime_help_bar").hide();

  document.getElementById("dummy-input").focus();

  imeVisible = false;

};

// -----------------------------------------------------