﻿
allowReturn = true;

// ----KEYS -------------------------------------

Key = {

  mute: 0,
  NMUTE: 0,
  YMUTE: 1

};

// ------------------------------------------------------

Key.keyPress = function (e) {

    //Main.log("keypress: " + event.keyCode);
    //StatusContainer.control.Status.setInfoText(event.keyCode);

    if (!allowReturn)
        return;

    if (Service.isBuilding)
        return;

    if (Service.isUpdating && event.keyCode != tvKey.KEY_RETURN)
        return;

    if (Template.isErrorDisplayed) {
        $("body").trigger('keyPressed', ["return"]);
        widgetAPI.blockNavigation(event);
        return;
    }

    if (Service.loaderVisible)
        return;

    var keyCode = event.keyCode;
    switch (keyCode) {
        //  case 40:     
        case 20000081:
        case tvKey.KEY_DOWN:
            //Main.log("keypress down");
            $("body").trigger('keyPressed', ["down"]);
            break;
        // case 38:      
        case 20000082:
        case tvKey.KEY_UP:
            //Main.log("keypress up");
            $("body").trigger('keyPressed', ["up"]);
            break;
        // case 37:       
        case 20000080:
        case tvKey.KEY_LEFT:
            //Main.log("keypress left");
            $("body").trigger('keyPressed', ["left"]);
            break;
        // case 39:    
        case 20000079:
        case tvKey.KEY_RIGHT:
            //Main.log("keypress right");
            $("body").trigger('keyPressed', ["right"]);
            break;
        case 20000040:
        case tvKey.KEY_ENTER:
            // case 13:
            //Main.log("keypress enter");
            $("body").trigger('keyPressed', ["enter"]);
            break;
        case 20000041:
        case tvKey.KEY_RETURN:
            // case 120:
            // case 8:
            //Main.log("keypress return");
            //Player.Stop();
            widgetAPI.blockNavigation(event);
            $("body").trigger('keyPressed', ["return"]);

            break;
        case tvKey.KEY_VOL_UP:
        case tvKey.KEY_PANEL_VOL_UP:
            if (this.mute == this.YMUTE)
                this.noMuteMode();

            Audio.setRelativeVolume(0);

            widgetAPI.blockNavigation(event);
            break;
        case tvKey.KEY_VOL_DOWN:
        case tvKey.KEY_PANEL_VOL_DOWN:
            if (this.mute == this.YMUTE)
                this.noMuteMode();

            Audio.setRelativeVolume(1);

            widgetAPI.blockNavigation(event);
            break;
        case tvKey.KEY_MUTE:
            this.muteMode();
            break;
        case 88:
        case tvKey.KEY_EXIT:
            //Main.log("keypress exit");
            //Main.log("!!!!!!!!!!!!!!!!!!!!! unload !!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
            widgetAPI.blockNavigation(event);
            Player.Stop();
            widgetAPI.sendExitEvent();
            break;
        case 20000058:
        case tvKey.KEY_RED:
            $("body").trigger('keyPressed', ["red"]);
            break;
        case 20000059:    
        case tvKey.KEY_GREEN:
            $("body").trigger('keyPressed', ["green"]);
            break;
        case 20000060:    
        case tvKey.KEY_YELLOW:
            $("body").trigger('keyPressed', ["yellow"]);
            break;
        case 20000061:    
        case tvKey.KEY_BLUE:
            $("body").trigger('keyPressed', ["blue"]);
            break;
        case tvKey.KEY_PAUSE:
            $("body").trigger('keyPressed', ["pause"]);
            break;
        case tvKey.KEY_PLAY:
            $("body").trigger('keyPressed', ["play"]);
            break;
        case tvKey.KEY_STOP:
            $("body").trigger('keyPressed', ["stop"]);
            break;
    }

}

// -----------------------------------------------------

Key.sendReturn = function () {

  widgetAPI.sendReturnEvent();

}

// -----------------------------------------------------

Key.setMuteMode = function () {
  //Log.write("setMuteMode");
  if (this.mute != this.YMUTE) {
    Audio.plugin.SetUserMute(true);
    this.mute = this.YMUTE;
  }
};

// -----------------------------------------------------

Key.noMuteMode = function () {
  //Log.write("noMuteMode");
  if (this.mute != this.NMUTE) {
    Audio.plugin.SetUserMute(false);
    this.mute = this.NMUTE;
    //alert("Audio.plugin.SetUserMute(false)");
  }
};

// -----------------------------------------------------

Key.muteMode = function () {
  switch (this.mute) {
    case this.NMUTE:
      //Log.write("NMUTE setMuteMode()");
      this.setMuteMode();
      break;

    case this.YMUTE:
      //Log.write("YMUTE noMuteMode()");
      this.noMuteMode();
      break;

    default:
      //Log.write("ERROR: unexpected mode in muteMode");
      break;
  }
};

// -----------------------------------------------------



