﻿
// ----FOCUS -------------------------------------

Focus = {

  map : null,
  state : null,
  OPEN: 1,
  CLOSED: 2,
  focusedControlId : null,
  lastFocus: null

};

// ------------------------------------------------------

Focus.init = function () {

  var _this = this;

  this.state = this.OPEN;

  //----

  $.ajax({
    url: "focus-map.json",
    dataType: 'json',
    data: null,
    success: function (data) {
      //Main.log("load focus-map.json success.");
      _this.map = data;
    },
    error: function () {
      //Main.logError("load json file error: focus-map.json");
    }
  });

  //----

  $("body").bind("controlEvent", function (event, message, controlId) {

    switch (message) {
      case "takeControl":
        //Main.log("Focus takeControl " + controlId);
        _this.state = _this.CLOSED;
        _this.focusedControlId = controlId;
        _lastFocus = controlId;
        break;
      case "leaveControl":
        //Main.log("Focus leaveControl " + controlId);
        _this.clearFocus();
        _this.state = _this.OPEN;
        break;
    }

  });

  //----

  $("body").bind("keyPressed", function (event, direction) {

    //Main.log("Focus keyPressed " + direction + " " + _this.state + " " + _this.focusedControlId);

    $("body").trigger('controlKeyPressed' + _this.focusedControlId, [direction, _this.focusedControlId]);

    if (_this.state == _this.CLOSED)
      return;

    if (direction == "enter") {
      $("body").trigger('enterKeyPressed', [_this.focusedControlId]);
    }

    var focused = $(".focus");

    if (focused.attr("id") == undefined) {
      //Main.log("Focus id undefined !!!!!!!!!!!!!!!!!!");
      focused = $("#" + _this.lastFocus);
    }

    var nextElement;

    switch (direction) {
      case "down":
        //Main.log("Focus down " + focused.attr("id"));
        if (focused.attr("id") != undefined) {
          nextElement = eval("Focus.map.Elements." + focused.attr("id") + ".Down");
        }
        break;
      case "up":
        //Main.log("Focus up " + focused.attr("id"));
        if (focused.attr("id") != undefined) {
          nextElement = eval("Focus.map.Elements." + focused.attr("id") + ".Up");
        }
        break;
      case "left":
        //Main.log("Focus left " + focused.attr("id"));
        if (focused.attr("id") != undefined) {
          nextElement = eval("Focus.map.Elements." + focused.attr("id") + ".Left");
        }
        break;
      case "right":
        //Main.log("Focus right " + focused.attr("id"));
        if (focused.attr("id") != undefined) {
          nextElement = eval("Focus.map.Elements." + focused.attr("id") + ".Right");
        }
        break;
      case "return":
      case "parent":
        //Main.log("Focus parent " + focused.attr("id"));
        if (focused.attr("id") != undefined) {
          nextElement = eval("Focus.map.Elements." + focused.attr("id") + ".Parent");
        }
        break;
    }

    //Main.log("Next element: " + nextElement);

    if (nextElement == undefined)
      return;

    if (nextElement != "") {
      _this.setFocusToElement($(nextElement));
    }

  });

  //----

}

// ------------------------------------------------------

Focus.setFocusToElement = function (element) {

  //Main.log("Focus.setFocusToElement " + element.attr("id"));
  ////Main.log(element);

  this.focusedControlId = element.attr("id");

  this.clearFocus();
  //this.state = this.OPEN;

  element.addClass("focus");
  $(element).trigger('focusSet', [element]);

}

// ------------------------------------------------------

Focus.setFocusedControlId = function (controlId) {

    //Main.log("Focus.setFocusedControlId ----------------------------------: " + controlId);

    $("body").trigger('controlEvent', ["takeControl", controlId]);

    //this.focusedControlId = controlId;

    Focus.setFocusToElement($("#" + controlId));

}

// ------------------------------------------------------

Focus.clearFocus = function () {

  //Main.log("Focus clearFocus from " + $(".focus").attr("id"));

  this.lastFocus = $(".focus").attr("id");
  $(".focus").removeClass("focus");

}

// ------------------------------------------------------

// zmena Pepa -------------------------------------------


Focus.hasNextElement = function (direction) {

    if (direction == "return") direction = "parent";

    var focused = $(".focus");
    var nextElement;

    //Main.log("Focus parent " + focused.attr("id"));
    if (focused.attr("id") != undefined) {
        nextElement = eval("Focus.map.Elements." + focused.attr("id") + "." + this.capitaliseFirstLetter(direction));
    }

    return nextElement;

}
// -----------------------------------------------------

Focus.capitaliseFirstLetter = function (direction) {
    return direction.charAt(0).toUpperCase() + direction.slice(1);
}
// <<<  Pepa---------------------------------------------
