﻿
// ----SERVICE -------------------------------------

Service = {

  loader : null,
  isUpdating : false,
  isBuilding: false,
  loaderVisible : false

};


// ------------------------------------------------------

Service.init = function () {

  this.loader = $("#loader");
  this.loader.css("top", Main.setting.App.Preloader.Top);
  this.loader.css("left", Main.setting.App.Preloader.Left);

  var loaderImg = $("<img />");
  loaderImg.attr("src", Main.setting.App.Preloader.Path);
  

  this.loader.append(loaderImg);

};

// ------------------------------------------------------

Service.get = function (path, _data, resultType, callback) {

    var _this = this;


    if (_data == null)
        _data = "{}";

    //Main.log(path);
    //Main.log("Service data: " + _data);

    $.ajax({
        type: "POST",
        url: path,
        context: document.body,
        data: _data,
        timeout: Main.setting.Services.Timeout,
        dataType: "json",
        contentType: "application/x-www-form-urlencoded;charset=UTF8",
        beforeSend: function () {
            _this.isUpdating = true;
            _this.showLoader();
        },
        success: function (data) {

            //Main.log("service call success...");

            $("body").trigger('serviceResult', [data, "success", resultType, callback]);

            _this.hideLoader();
            _this.isUpdating = false;

        },
        error: function () {

            //Main.log("service error...");

            $("body").trigger('serviceResult', [null, "error", resultType, callback]);
            _this.hideLoader();
            _this.isUpdating = false;

        }

    });

};

// ------------------------------------------------------

Service.showLoader = function () {

    //Main.log("Service.showLoader");

    this.loaderVisible = true;

    this.loader.css("top", Main.setting.App.Preloader.Top);
    this.loader.css("left", Main.setting.App.Preloader.Left);

    this.loader.show();

};

// ------------------------------------------------------

Service.showLoaderWithPosition = function (setting) {

  //Main.log("Service.showLoader");

  this.loader.css("top", setting.Top);
  this.loader.css("left", setting.Left);

  this.loader.show();


};

// ------------------------------------------------------

Service.hideLoader = function () {

    //Main.log("Service.hideLoader");

  this.loaderVisible = false;

  this.loader.hide();

};

// ------------------------------------------------------
