
/// <reference path="../main.js"/>

/// <summary>Helper for displaying timeline in player.</summary>

var Timeline = {
    duration: 0,
    totalTime: 0
}

// ----------------------------------------------------
Timeline.init = function () {
    /// <summary>Timeline initialization.</summary>
  $("#timeline .progress").show().css("width", "0%");
}

// ----------------------------------------------------
Timeline.setTotalTime = function (total) {
    /// <summary>Set total time of the video to timeline object.</summary>
    this.totalTime = total;
}


// ----------------------------------------------------
Timeline.reset = function () {
    /// <summary>Start position for the timeline.</summary>

    var timeElement = $("#timeInfo .time");
    //timeElement.html("<span class='current'>0:00:00</span><span class='total'>/ 0:00:00</span>");
    timeElement.html("<span class='current'>00:00</span><span class='total'> 00:00</span>");
    $("#timeline .progress").hide().css("width", "0%");

}

// ----------------------------------------------------
Timeline.setTime = function (time) {
  /// <summary>Set current time of the video to timeline object.</summary>



  var timePercent = (100 * time) / this.totalTime;
  var timeElement = $("#timeInfo .time");
  var timeHTML = "";
  var timeHour = 0; var timeMinute = 0; var timeSecond = 0;
  var totalTimeHour = 0; var totalTimeMinute = 0; var totalTimesecond = 0;

  var timeElementCurrent = $("<span class='current'></span>");
  var timeElementTotal = $("<span class='total'></span>");

  //Log.write3(this.totalTime + " " + timePercent);

  $("#timeline .progress").show().css("width", timePercent + "%");
  $("#timeline .time-separator").html("/");

  if (Player.state == Player.PLAYING) {

    totalTimeHour = Math.floor(this.totalTime / 3600000);
    timeHour = Math.floor(time / 3600000);

    totalTimeMinute = Math.floor((this.totalTime % 3600000) / 60000);
    timeMinute = Math.floor((time % 3600000) / 60000);

    totalTimeSecond = Math.floor((this.totalTime % 60000) / 1000);
    timeSecond = Math.floor((time % 60000) / 1000);

    this.duration = (timeMinute * 60) + timeSecond;

    if (timeMinute == 0)
      timeHTML += "00:";
    else if (timeMinute < 10)
      timeHTML += "0" + timeMinute + ":";
    else
      timeHTML += timeMinute + " : ";

    if (timeSecond == 0)
      timeHTML += "00";
    else if (timeSecond < 10)
      timeHTML += "0" + timeSecond + "";
    else
      timeHTML += timeSecond + "";

    $(".time-current").html(timeHTML);
    //timeElementCurrent.text(timeHTML);
    timeHTML = "";

    if (totalTimeMinute == 0)
      timeHTML += "00:";
    else if (totalTimeMinute < 10)
      timeHTML += "0" + totalTimeMinute + ":";
    else
      timeHTML += "" + totalTimeMinute + ":";

    if (totalTimeSecond == 0)
      timeHTML += "00";
    else if (totalTimeSecond < 10)
      timeHTML += "0" + totalTimeSecond;
    else
      timeHTML += totalTimeSecond;
  }
  else {
    //timeHTML = "0 : 00 : 00 / 0 : 00 : 00";
    timeHTML = "00:00 00:00";
  }

  this.total = (totalTimeMinute * 60) + totalTimeSecond;
  $("#timeInfo .time-total").html(timeHTML);
  //timeElementTotal.text(timeHTML);



  //timeElement.html("<span class='current'>" + timeElementCurrent.text() + "</span><span class='total'>/ " + timeElementTotal.text() + "</span>");
  ////Log.write(timeElement.html());


}


