﻿
// ---- CAROUSEL -------------------------------------

CarouselContainer = {

  control: new Array()

};

$(document).ready(function () {

  $("body").bind("initMenuControls", function (event, message) {

    $("div[iscontrol=true][controltype=carousel]").each(function (index, item) {

      var name = $(item).attr("Id");
      name = new ControlCarousel(name);
      CarouselContainer.control[$(item).attr("Id")] = name;
      name.init();

      $("body").trigger('subControlCreated', [$(item).attr("Id"), $(item).attr("parent")]);

    });

  });

});

// constructor ---------------------------------------

function ControlCarousel(controlId) {

  this.controlId = controlId;
  this.control = $("#" + controlId);
  this.state = this.NOTFOCUSED;
  this.FOCUSED = 1;
  this.NOTFOCUSED = 2;
  this.visibleItemsCount = 5;
  this.lastFocus = 0;

  // -----------------------------------------

  this.init = function () {

    //Main.log(controlId + " init");

    var _this = this;

    //----

    $(this.control).bind("focusSet", function (event, element) {

      $("body").trigger('carouselSetFocus', [null]);
      _this.takeControl();

    });

    //----

    $("body").bind("enterKeyPressed" + this.controlId, function (event, controlId) {

      if (_this.controlId != controlId)
        return;

      if (_this.state != _this.FOCUSED) {
        ////Main.log("enter pressed in: " + controlId);
        //_this.state = _this.FOCUSED;
        //$("body").trigger('controlEvent', ["takeControl", _this.controlId]);
        //_this.setFirstFocus();
      } else {

      }

    });

    //----

    $("body").bind("controlKeyPressed" + this.controlId, function (event, direction, controlId) {

      if (_this.controlId != controlId)
        return;

      //Main.log("control " + controlId + " keyPressed " + direction);

      if (_this.state == _this.FOCUSED) {

        switch (direction) {
          case "up":
            _this.moveUp();
            break;
          case "down":
            _this.moveDown();
            break;
          case "left":
            _this.moveLeft();
            break;
          case "right":
            _this.moveRight();
            break;
          case "enter":
            _this.state = _this.NOTFOCUSED;
            var index = $(".controlFocus", _this.control).attr("title");
            _this.lastFocus = index;
            _this.clearFocus();
            $("body").trigger('carouselEnterPressed', [index]);
            break;
          case "return":
            $("body").trigger('carouselReturnPressed', [null]);
            _this.leaveControl();
            _this.deinit();
            break;
        }
      }

    });

    //----

  };

  // -----------------------------------------

  this.getControlName = function () {
    return controlId;
  };

  // -----------------------------------------

  this.deinit = function () {

    $(this.control).unbind("focusSet");
    $("body").unbind("enterKeyPressed" + this.controlId);
    $("body").unbind("controlKeyPressed" + this.controlId);

    this.hide();
    this.control.html("");

  };

  // -----------------------------------------

  this.hide = function () {

    this.control.hide();

  };

  // -----------------------------------------

  this.show = function () {

    this.control.show();

  };

  // -----------------------------------------

  this.takeControl = function () {

    //Main.log("control " + this.controlId + " takeControl");

    this.state = this.FOCUSED;
    this.setFirstFocus();
    $("body").trigger('controlEvent', ["takeControl", this.controlId]);

  };

  // -----------------------------------------

  this.leaveControl = function (direction) {

    //Main.log("control " + this.controlId + " leaveControl focus in " + $(".controlFocus", this.control).attr("title"));

    this.state = this.NOTFOCUSED;
    this.lastFocus = $(".controlFocus", this.control).attr("title");
    this.clearFocus();
    $("body").trigger('controlEvent', ["leaveControl", null]);
    //$("body").trigger('keyPressed', [direction]);

  };

  // -----------------------------------------

  this.setFirstFocus = function () {

    //Main.log("Carousel.setFirstFocus: " + this.lastFocus);

    $("li:eq(" + this.lastFocus + ")", this.control).addClass("controlFocus");

    var index = $(".controlFocus", this.control).attr("title");
    var src = $("img", $(".container", $(".controlFocus", this.control))).attr("src");
    $("body").trigger('carouselAfterMove', ["first", src, index]);

  };

  // -----------------------------------------

  this.clearFocus = function () {

    //this.lastFocus = $(".controlFocus", this.control).attr("title");
    $("#" + this.controlId + " .controlFocus").removeClass("controlFocus");

  };

  // -----------------------------------------

  this.moveLeft = function () {

    if ($(".controlFocus", this.control).prev().length == 0) {
      return;
    }

    if ($(".controlFocus", this.control).prev().attr("visible") == "false") {
      $("li[visible=true]", this.control).last().attr("visible", "false").css("display", "none");
      $(".controlFocus", this.control).prev().attr("visible", "true").css("display", "inline-block");
    }

    $(".controlFocus", this.control).removeClass("controlFocus").prev().addClass("controlFocus").css("display", "inline-block");

    var index = $(".controlFocus", this.control).attr("title");
    var src = $("img", $(".container", $(".controlFocus", this.control))).attr("src");
    this.lastFocus = $(".controlFocus", this.control).attr("title");
    $("body").trigger('carouselAfterMove', ["left", src, index]);

  };

  // -----------------------------------------

  this.moveRight = function () {


    if ($("#" + this.controlId + " .controlFocus").next().length == 0) {
      return;
    }

    if ($(".controlFocus", this.control).next().attr("visible") == "false") {
      $("li[visible=true]", this.control).first().attr("visible", "false").css("display", "none");
      $(".controlFocus", this.control).next().attr("visible", "true").css("display", "inline-block");
    }

    $("#" + this.controlId + " .controlFocus").removeClass("controlFocus").next().addClass("controlFocus").css("display", "inline-block");

    var index = $(".controlFocus", this.control).attr("title");
    var src = $("img", $(".container", $(".controlFocus", this.control))).attr("src");
    this.lastFocus = $(".controlFocus", this.control).attr("title");
    $("body").trigger('carouselAfterMove', ["right", src, index]);

  };

  // -----------------------------------------

  this.moveUp = function () {

    this.lastFocus = $(".controlFocus", this.control).attr("title");
    this.clearFocus();
    $("body").trigger('carouselFocusMove', ["up"]);

  };

  // -----------------------------------------

  this.moveDown = function () {

  };

  // -----------------------------------------

  this.createContent = function (items) {

    var _this = this;

    this.lastFocus = 0;

    $(this.control).html("");

    var leftControl = $("<div />").addClass("leftArrow");
    var rightControl = $("<div />").addClass("rightArrow");

    var frame = $("<div />").addClass("frame");

    var carousel = $("<ul />").addClass("carousel-container");

    $(items).each(function (index, item) {
      var li = $("<li />");
      li.attr("title", index);

      if (_this.visibleItemsCount > index) {
        li.attr("visible", "true").css("display", "in-line");
      } else {
        li.attr("visible", "false").css("display", "none");
      }

      var border = $("<div />").addClass("thumbBorder");
      var thumbTitle = $("<div />").html(item.Title).addClass("thumbTitle");
      var thumbDate = $("<div />").html(item.PubDate).addClass("thumbDate");
      var container = $("<div />").addClass("container");
      var img = $("<img />");

      img.attr("src", item.ThumbnailUrl);

      ////Main.log(item.ThumbnailUrl);

      container.append(img);
      container.append(thumbTitle);
      container.append(thumbDate);

      li.append(border);
      li.append(container);


      carousel.append(li);
    });

    this.control.append(leftControl);
    frame.append(carousel);
    this.control.append(frame);
    this.control.append(rightControl);

  };

  // -----------------------------------------

}


