﻿// ---- IMPRESSUM -------------------------------------

ImpressumContainer = {

    control: new Array()

};

$(document).ready(function () {

    $("body").bind("initControls", function (event, message) {

      $("div[iscontrol=true][controltype=impressum]").each(function (index, item) {

            var name = $(item).attr("Id");
            name = new ControlImpressum(name);
            ImpressumContainer.control[$(item).attr("Id")] = name;
            name.init();

            $("body").trigger('controlCreated', [null]);

        });

    });

});

// constructor ---------------------------------------

function ControlImpressum(controlId) {

  this.controlId = controlId;
  this.control = $("#" + controlId);
  this.state = this.NOTFOCUSED;
  this.FOCUSED = 1;
  this.NOTFOCUSED = 2;
  this.text = null;
  this.step = 20;

  // -----------------------------------------

  this.init = function () {

      //Main.log(controlId + " init");

      var _this = this;

      this.position = 1;
      // this.sid = "9ebfce9ee7cac372e5eaae56e037a5eb";

      //----

      $(this.control).bind("enterKeyPressed", function (event, message) {
          //Main.log("enter pressed in: " + controlId);

          if (_this.state != _this.FOCUSED) {
              _this.state = _this.FOCUSED;
              $("body").trigger('controlEvent', ["takeControl", _this.controlId]);
              _this.setFirstFocus();
          } else {

          }

      });

      //----

      $("body").bind("controlKeyPressed" + this.controlId, function (event, direction, controlId) {

          if (_this.controlId != controlId)
              return;

          if (_this.state == _this.FOCUSED) {

              switch (direction) {
                  case "up":
                      _this.moveUp();
                      break;
                  case "down":
                      _this.moveDown();
                      break;
                  case "left":
                      break;
                  case "right":
                      break;
                  case "enter":
                      //_this.state = _this.NOTFOCUSED;
                      //_this.clearFocus();
                    //$("body").trigger('remoteEnterPressed', [null]);
                      _this.deinit();
                      $("body").trigger('impressumReturnPressed', [null]);
                      //_this.checkClosing();
                      break;

                  case "return":
                      //_this.leaveControl();
                      _this.deinit();
                      $("body").trigger('impressumReturnPressed', [null]);
                      break;
              }
          }
      });

  };

  // -----------------------------------------

    this.getControlName = function () {
        return controlId;
    };

    // -----------------------------------------

    this.loadContent = function () {

      var _this = this;

      $("#Impressum .formular").load('impressum.html', function () {
        //Main.log(_this);
        _this.show();
        _this.takeControl();
        //_this.fillText();
        Service.get(Main.setting.Server + "Json/JsonWebService.aspx?Client=SamsungTV&cc=DE-DE&EplName=FCBayern&ServiceOperation=GetContent&PageType=Imprint", null, "impressum", "impressumFillText");
        Focus.setFocusToElement($("#Impressum"));
      });

    };

  // -----------------------------------------

  this.deinit = function () {

      this.hide();
      $("#Impressum .formular .text").html("");

  };

  // -----------------------------------------

  this.hide = function () {

    //Main.log("Impressum hide");

    this.control.hide();

  };

  // -----------------------------------------

  this.show = function () {

    //Main.log("Impressum show: " + this.control.html());

    this.control.show();

  };

  // -----------------------------------------

  this.takeControl = function () {
    this.state = this.FOCUSED;
    this.setFirstFocus();
    $("body").trigger('controlEvent', ["takeControl", this.controlId]);
  };

  // -----------------------------------------

  this.leaveControl = function (direction) {

    this.state = this.NOTFOCUSED;
    this.clearFocus();
    $("body").trigger('controlEvent', ["leaveControl", null]);

  };

  // -----------------------------------------

  this.setFirstFocus = function () {

      $("div[impressum='text-container']", this.control).first().addClass("control-focus");

  };

  // -----------------------------------------

  this.clearFocus = function () {

      $(".control-focuse", this.control).removeClass("control-focus");

  };

  // -----------------------------------------

  this.checkClosing = function () {

      if ($("div[impressum].control-focus", this.control).attr("impressum") != "text-container") {

          this.leaveControl();
          this.deinit();
          $("body").trigger('impressumReturnPressed', [null]);
       }

  };

  // -----------------------------------------

  this.moveUp = function () {

      if ($("div[impressum].control-focus", this.control).attr("impressum") == "text-container") {

          var top = $("div[impressum='text']", this.control).position().top;

          var height = $("div[impressum='text']", this.control).height();
          var height2 = $("div[impressum='text-container']", this.control).height();

          var scrolerbarheight = $(".scroler-bar", this.control).height();
          var scrolerheight = $(".scroler", this.control).height();

          if (top != 0) {

              $("div[impressum='text']", this.control).css("top", (top + this.step));
              $(".scroler", this.control).css("top", ($(".scroler", this.control).position().top + (scrolerbarheight - scrolerheight) / ((height2 - height) / this.step)));
              return;
          }
      }

      //Main.log("impressum prev: " + $("div[impressum].control-focus", this.control).prev().attr("impressum"));

      if ($("div[impressum].control-focus", this.control).prev().attr("impressum") == undefined) {
          return;
      }

      $("div[impressum].control-focus", this.control).removeClass("control-focus").prev().addClass("control-focus");

      if ($("div[impressum].control-focus", this.control).attr("impressum") == "text-container") {

          $(".scroler-bar", this.control).first().show();
      } else {
          $(".scroler-bar", this.control).first().hide();  
      }
  };

  // -----------------------------------------

  this.moveDown = function () {

      if ($("div[impressum].control-focus", this.control).attr("impressum") == "text-container") {

          var top = $("div[impressum='text']", this.control).position().top;
          var height = $("div[impressum='text']", this.control).height();
          var height2 = $("div[impressum='text-container']", this.control).height();

          var scrolerbarheight = $(".scroler-bar", this.control).height();
          var scrolerheight = $(".scroler", this.control).height();

          if (top > (height2 - height)) {

              $("div[impressum='text']", this.control).css("top", (top - this.step));
              $(".scroler", this.control).css("top", ($(".scroler", this.control).position().top - (scrolerbarheight - scrolerheight) / ((height2 - height) / this.step)));
              return;
          }
      }

      //Main.log("impressum next: " + $("div[impressum].control-focus", this.control).next().attr("impressum"));

      if ($("div[impressum].control-focus", this.control).next().attr("impressum") == undefined) {
          return;
      }

      $("div[impressum].control-focus", this.control).removeClass("control-focus").next().addClass("control-focus");

      if ($("div[impressum].control-focus", this.control).attr("impressum") == "text-container") {
          $(".scroler-bar", this.control).first().show();
      } else {
          $(".scroler-bar", this.control).first().hide();
      }
  };

  // -----------------------------------------

  this.fillText = function (data) {

    var _this = this;

    //Main.log("fillText()");

    $(".scroler, .text", this.control).css("top", 0);

    $('#' + this.controlId + ' .title').html("Impressum");

    ////Main.log(data.Text);
    $('#' + this.controlId + ' .text').first().html(data.Text);

  };

  // -----------------------------------------


}