﻿// ---- IMPRESSUM -------------------------------------

IntroContainer = {

  control: new Array()

};

$(document).ready(function () {

  $("body").bind("initControls", function (event, message) {

    $(".intro.control").each(function (index, item) {

      var name = $(item).attr("Id");
      name = new ControlIntro(name);
      IntroContainer.control[$(item).attr("Id")] = name;
      name.init();

      $("body").trigger('controlCreated', ["intro"]);

    });

  });

});

// constructor ---------------------------------------

function ControlIntro(controlId) {

  this.controlId = controlId;
  this.control = $("#" + controlId);
  this.state = this.NOTFOCUSED;
  this.FOCUSED = 1;
  this.NOTFOCUSED = 2;

  this.VIDEO = 3;
  this.IMAGE = 4;

  this.mediaFile = null;
  this.introType = null;
  this.timer = null;

  // -----------------------------------------

  this.init = function () {

    //Main.log(controlId + " init");

    var _this = this;

    //----

    $("body").bind("controlKeyPressed" + this.controlId, function (event, direction, controlId) {

      if (_this.controlId != controlId)
        return;

      if (_this.state == _this.FOCUSED) {

        switch (direction) {
          case "up":
            break;
          case "down":
            break;
          case "left":
            break;
          case "right":
            break;
          case "enter":
            break;
          case "return":
            break;
        }
      }
    });

  };

  // -----------------------------------------

  this.getControlName = function () {
    return controlId;
  };

  // -----------------------------------------

  this.deinit = function () {


  };

  // -----------------------------------------

  this.hide = function () {

    this.control.hide();

  };

  // -----------------------------------------

  this.show = function () {

    this.control.show();

  };

  // -----------------------------------------

  this.takeControl = function () {

    this.state = this.FOCUSED;
    this.setFirstFocus();
    $("body").trigger('controlEvent', ["takeControl", this.controlId]);

  };

  // -----------------------------------------

  this.leaveControl = function (direction) {

    this.state = this.NOTFOCUSED;
    this.clearFocus();
    $("body").trigger('controlEvent', ["leaveControl", null]);

  };

  // -----------------------------------------

  this.setFirstFocus = function () {


  };

  // -----------------------------------------

  this.clearFocus = function () {

    $(".control-focuse", this.control).removeClass("control-focus");

  };

  // -----------------------------------------

  this.create = function (data) {

      // ### temp intro image
      // data.CovControl = "IntroImage";

      switch (data.CovControl) {
          case "IntroVideo":
              //Main.log("Intro create video...");
              this.mediaFile = data.Content;
              this.introType = this.VIDEO;
              $("body").trigger('createIntro', ["video"]);
              break;
          case "IntroImage":
              //Main.log("Intro create image...");
              this.mediaFile = data.Content;
              this.introType = this.IMAGE;
              this.timer = data.Timer;

              // ### temp intro image
              // this.mediaFile = "Theme/FCBayern/Images/IntroImage.jpg";
              // this.timer = 2000;



              $("body").trigger('createIntro', ["image"]);
              break;

      };

      // -----------------------------------------

      this.introFinished = function () {
          this.hide();
          $("body").trigger('introFinished', [null]);
      };

      // -----------------------------------------


  };

  // -----------------------------------------

}