﻿
// ---- LOGIN -------------------------------------

LoginContainer = {

  control: new Array()

};

$(document).ready(function () {

  $("body").bind("initControls", function (event, message) {

    $("div[iscontrol=true][controltype=login]").each(function (index, item) {

      var name = $(item).attr("Id");
      name = new ControlLogin(name);
      LoginContainer.control[$(item).attr("Id")] = name;
      name.init();

      $("body").trigger('controlCreated', [null]);

    });

  });

});

// constructor ---------------------------------------

function ControlLogin(controlId) {

  this.controlId = controlId;
  this.control = $("#" + controlId);
  this.state = this.NOTFOCUSED;
  this.FOCUSED = 1;
  this.NOTFOCUSED = 2;
  this.checked = false;
  this.login = "";
  this.passwd = "";
  this.userName = "";
  this.sid = "";
  this.position = 1;
  this.stremurl = "";
  //this.videoIndex = "";
  this.sourceUrl = "";
  this.data = null;
  this.isUserLogged = false;
  this.isStartAuthentication = false;
  this.isFormVisible;

  // -----------------------------------------

  this.init = function () {

    //Main.log(controlId + " init");

    var _this = this;

    this.position = 1;
    // this.sid = "9ebfce9ee7cac372e5eaae56e037a5eb";

    //----

    $(this.control).bind("enterKeyPressed", function (event, message) {
      //Main.log("enter pressed in: " + controlId);

      if (_this.state != _this.FOCUSED) {
        _this.state = _this.FOCUSED;
        $("body").trigger('controlEvent', ["takeControl", _this.controlId]);
        _this.setFirstFocus();
      } else {

      }

    });

    //----

    $("body").bind("controlKeyPressed" + this.controlId, function (event, direction, controlId) {

      if (_this.controlId != controlId)
        return;

      //Main.log("control " + controlId + " keyPressed " + direction);

      if (_this.state == _this.FOCUSED) {

        switch (direction) {
          case "up":
            _this.moveUp();
            break;
          case "down":
            _this.moveDown();
            break;
          case "left":
            _this.moveLeft();
            break;
          case "right":
            _this.moveRight();
            break;
          case "enter":
            //_this.state = _this.NOTFOCUSED;
            //_this.clearFocus();
            //$("body").trigger('remoteEnterPressed', [null]);

            //Main.log("position: " + _this.position);

            switch (_this.position) {

              case 0: _this.leaveControl();
                _this.hide();
                $("body").trigger('loginReturnPressed', [null]);
                break;
              case 3: _this.check();
                //Main.log("case 3")
                break;

              default:
                _this.login = encodeURI($("input:text[name=login]").val());
                _this.passwd = encodeURI($("input:password[name=paswd]").val());
                //_this.login = $("input:text[name=login]").val();
                //_this.passwd = $("input:password[name=paswd]").val();
                _this.tryLogin();
                break;
            }

            break;

          case "return":
            _this.leaveControl();
            _this.hide();
            $("body").trigger('loginReturnPressed', [null]);
            break;
        }
      }

    });


    // ---

    $("body").bind("serviceResult", function (event, data, status, resultType, callback) {

      switch (status) {
        case "success":
          if (resultType == "login") {
            _this.data = data;
            _this.loged();
          }
          if (resultType == "streamurl") {
            //Main.log("resultType == streamurl");
            _this.data = data;
            _this.wasSidValid();
          }
          break;
        case "error":
          break;
      }

    });

    // ---

  };



  // -----------------------------------------

  this.saveSidToCookie = function () {

  //Main.log("Login: saveSidToCookie " + this.sid);

  //$.cookie('sid', this.sid);
  Storage.put('sid', this.sid);

  };

  // -----------------------------------------

  this.saveToCookie = function () {

    //Main.log("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! Login: saveToCookie " + this.login + " " + this.passwd + " " + this.checked + " " + this.sid);

    Storage.put('username', this.userName);
    Storage.put('login', this.login);
    Storage.put('password', this.passwd);
    Storage.put('remember', this.checked);
    Storage.put('sid', this.sid);

    //    $.cookie('username', this.login);
    //    $.cookie('password', this.passwd);
    //    $.cookie('remember', this.checked);
    //    $.cookie('sid', this.sid);

  };

  // -----------------------------------------
  this.loadFromCokie = function () {

    this.userName = Storage.getItem('username');
    this.login = Storage.getItem('login');
    this.passwd = Storage.getItem('password');
    this.checked = Storage.getItem('remember');
    this.sid = Storage.getItem('sid');

    //Main.log("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! Login: loadFromCokie " + this.login + " " + this.passwd + " " + this.checked + " " + this.sid);


    //    this.checked = $.cookie('remember');
    //    this.login = $.cookie('username');
    //    this.passwd = $.cookie('password');
    //    this.sid = $.cookie('sid');

    //    //Main.log("load Cookie " + $.cookie('remember') + " " + $.cookie('username') + " " + $.cookie('password') + " " + $.cookie('sid'));

  };

  // -----------------------------------------


  this.startAuthentication = function (sourceUrl) {

    this.isStartAuthentication = true;
    this.sourceUrl = sourceUrl;

    this.loadFromCokie();

    //Main.log("sid: " + this.sid)
    //    if (this.sid == "" || this.sid == null) {
    //      if ((this.login != "" && this.login != null) && (this.passwd != "" && this.passwd != null)) {
    //        this.tryLogin();
    //      }
    //      else this.startLoginForm();
    //    } else {
    //      this.loadFromCokie();
    //      //Main.log("sid: " + this.sid);
    //      this.getStreamUrl();
    //    }

    if (this.sid == "" || this.sid == null) {

      if ((this.login != "" && this.login != null) && (this.passwd != "" && this.passwd != null)) {
        this.tryLogin();

      }
      else {

      if(!this.isUserLogged)
        this.startLoginForm();

      }
  } else {

      this.loadFromCokie();
      //Main.log("sid: " + this.sid);
      this.getStreamUrl();

    }

  };

  // -----------------------------------------

  this.getControlName = function () {
    return controlId;
  };

  // -----------------------------------------

  this.startLoginForm = function () {

    $("#Login .formular").load('login.html', function () {
      $("body").trigger('loginShow', [null]);
    });

  };

  // -----------------------------------------

  this.deinit = function () {

    //$(this.control).unbind("focusSet");
    //$(this.control).unbind("enterKeyPressed" + this.controlId);
    //$("body").unbind("controlKeyPressed" + this.controlId);

    this.isStartAuthentication = false;
    this.login = "";
    this.passwd = "";
    //this.sid = "";
    this.position = 1;

    //this.hide();
    $("#Login .formular").html("");

  };

  // -----------------------------------------

  this.hide = function () {

    if (this.isFormVisible)
      $("body").trigger('loginFormLeave', [null]);

    this.control.hide();
    this.deinit();

    this.isFormVisible = false;

  };

  // -----------------------------------------

  this.show = function () {

    this.isFormVisible = true;
    this.control.show();

  };

  // -----------------------------------------

  this.takeControl = function () {
    this.state = this.FOCUSED;
    this.setFirstFocus();
    $("body").trigger('controlEvent', ["takeControl", this.controlId]);
  };

  // -----------------------------------------

  this.leaveControl = function (direction) {

    this.state = this.NOTFOCUSED;
    this.clearFocus();
    $("body").trigger('controlEvent', ["leaveControl", null]);

  };

  // -----------------------------------------

  this.setFirstFocus = function () {

    $("[focusable]:eq(1)", this.control).addClass("control-focus");

    // TEMP INPUT
    // document.getElementById("dummy-input").focus();
    Input.hideInput();

    $("body").trigger('loginSetFirstFocus', [null]);

  };

  // -----------------------------------------

  this.clearFocus = function () {

    $(".control-focus", this.control).removeClass("control-focus");

  };

  // -----------------------------------------

  this.moveLeft = function () {


  };

  // -----------------------------------------

  this.moveRight = function () {


  };

  // -----------------------------------------

  this.moveUp = function () {

    if ($("[focusable]", $(".control-focus", this.control).parent().prev()).length == 0) {
      return;
    }

    $("[focusable]", $(".control-focus", this.control).removeClass("control-focus").parent().prev()).addClass("control-focus");

    this.position--;

    $("body").trigger('loginMove', ["up", $(".control-focus", this.control).attr("id")]);


  };

  // -----------------------------------------

  this.moveDown = function () {

    if ($("[focusable]", $(".control-focus", this.control).parent().next()).length == 0) {
      return;
    }

    $("[focusable]", $(".control-focus", this.control).removeClass("control-focus").parent().next()).addClass("control-focus");

    this.position++;

    $("body").trigger('loginMove', ["down", $(".control-focus", this.control).attr("id")]);

  };

  // -----------------------------------------

  this.check = function () {

    if (this.checked && this.checked != null) {
      $("#" + this.controlId + " .checkboxImage").hide();
      this.checked = false;
      //Main.log("check() false");
    } else {
      $("#" + this.controlId + " .checkboxImage").show();
      this.checked = true;
      //Main.log("check() true");
    }

  };

  // -----------------------------------------

  this.tryLogin = function () {

    //Main.log("Login.tryLogin: " + this.login + " " + this.passwd);

    if (this.login == "" || this.passwd == "") {
      $(".errorBox").html("Bitte füllen Sie Benutzername und Passwort!");
      return;
    }

    var surl = Main.setting.Services.Login + "user=" + this.login + "&pass=" + this.passwd;
    //surl = surl.replace("(user)", this.login);
    //surl = surl.replace("(passwd)", this.passwd);
    //Main.log("surl:" + surl);
    Service.get(surl, null, "login", "loged");

  };

  // -----------------------------------------

  this.login = function () {

    this.loadFromCokie();

    if (this.login == "" || this.passwd == "") {
      $(".errorBox").html("Bitte füllen Sie Benutzername und Passwort!");
      return;
    }

    var surl = Main.setting.Services.Login + "user=" + this.login + "&pass=" + this.passwd;
    //surl = surl.replace("[user]", this.login);
    //surl = surl.replace("[passwd]", this.passwd);
    //Main.log("surl:" + surl);
    Service.get(surl, null, "login", "loged");
  };

  // -----------------------------------------

  this.logout = function () {

    //this.sid = "";
    this.isUserLogged = false;

    Storage.clearFile();

  }

  // -----------------------------------------

  this.getStreamUrl = function () {

    //Main.log("getStreamUrl");

    var url = this.sourceUrl; // Template.dataVideo.Content.ContentItems[this.videoIndex].MediaUrl;
    var surl = Main.setting.Services.StreamUrl;
    surl = surl.replace("[sid]", this.sid);
    surl = surl.replace("[surl]", url);
    Service.get(surl, null, "streamurl", "wasSidValid");
  };

  // -----------------------------------------

  this.wasSidValid = function () {

    //Main.log("wasSidValid: checking sid");

    //Main.log("LoginContainer.control.Login.streamurl.StreamUrl: " + this.data.streamUrl);

    if (this.data.streamUrl != undefined) {

      $("body").trigger('doAuthenticatedAction', [this.data.streamUrl]);
      this.hide();

    } else {

      //this.startLoginForm();
      this.tryLogin();

    }

  };

  // -----------------------------------------

  this.loged = function () {

    //Main.log("loged()");

    $(".errorBox").html("");

    if (this.data.error == undefined) {

      this.isUserLogged = true;
      this.userName = this.data.firstName + " " + this.data.lastName;

      $("body").trigger('loginStatusChange', ['logged', this.userName]);

      //Main.log("LoginContainer.control.Login.AutenficateDate.hasFcbTv : " + this.data.hasFcbTv);

      if (this.data.hasFcbTv) {

        //Main.log("loged() - hasFcbTv == 1 " + this.data.sid);
        this.sid = this.data.sid;

        this.saveSidToCookie();


        if (this.checked) {
          this.saveToCookie();
        }


        if (this.isStartAuthentication) {
          this.getStreamUrl();
        } else {
          this.hide();
        }


        //this.getStreamUrl();

      } else {
        //Main.log("loged() - hasFcbTv == 0");
        $(".errorBox").html("Bitte erwerben Sie ein Abo für FCB.tv, um dieses Video ansehen zu können.");
        //alert("Bitte erwerben Sie ein Abo für FCB.tv, um dieses Video ansehen zu können.");
      }

    } else {
      $(".errorBox").html("Sie konnten nicht angemeldet werden.");
    }


  };

  // ----------------------------------

}


