﻿
// ---- MATCHAKTUEL -------------------------------------

MatchAktuelContainer = {

  control: new Array()

};

$(document).ready(function () {

  $("body").bind("initMatchControls", function (event, message) {

    $("div[iscontrol=true][controltype=matchAktuel]").each(function (index, item) {

      var name = $(item).attr("Id");
      name = new ControlMatchAktuel(name);
      MatchAktuelContainer.control[$(item).attr("Id")] = name;
      name.init();

      $("body").trigger('subControlCreated', [$(item).attr("Id"), $(item).attr("parent")]);

    });

  });

});

// constructor ---------------------------------------

function ControlMatchAktuel(controlId) {

  this.controlId;
  this.control = $("#" + controlId);
  this.state = this.NOTFOCUSED;
  this.FOCUSED = 1;
  this.NOTFOCUSED = 2;
  this.datum = "";

  this.Team1Image = "";
  this.Team2Image = "";
  this.Team1 = "";
  this.Team2 = "";
  this.UpdateTimespan = 10;

  // -----------------------------------------

  this.init = function () {

    //Main.log(controlId + " init");

    var _this = this;

    //----

    $(this.control).bind("enterKeyPressed", function (event, message) {
      //Main.log("enter pressed in: " + controlId);

    //      if (_this.state != _this.FOCUSED) {
    //        _this.state = _this.FOCUSED;
    //        $("body").trigger('controlEvent', ["takeControl", _this.controlId]);
    //        _this.setFirstFocus();
    //      } else {

    //      }

    });

    //----

    $("body").bind("controlKeyPressed" + this.controlId, function (event, direction, controlId) {

      if (_this.controlId != controlId)
        return;

      if (_this.state == _this.FOCUSED) {

        switch (direction) {
          case "up":
            _this.moveUp();
            break;
          case "down":
            _this.moveDown();
            break;
          case "left":
            _this.moveLeft();
            break;
          case "right":
            _this.moveRight();
            break;
          case "enter":
            //_this.state = _this.NOTFOCUSED;
            //_this.clearFocus();
            //$("body").trigger('remoteEnterPressed', [null]);
            break;
          case "return":
            _this.leaveControl();
            _this.deinit();
            $("body").trigger('matchAktuelReturnPressed', [null]);
            break;
        }
      }

    });

    //----

  };

  // -----------------------------------------

  this.getControlName = function () {
    return controlId;
  };

  // -----------------------------------------

  this.deinit = function () {

    this.hide();
    this.control.html("");

  };

  // -----------------------------------------

  this.hide = function () {

    this.control.hide();

  };

  // -----------------------------------------

  this.show = function () {

    this.control.show();

  };

  // -----------------------------------------

  this.takeControl = function () {
    this.state = this.FOCUSED;
    this.setFirstFocus();
    $("body").trigger('controlEvent', ["takeControl", this.controlId]);
  };

  // -----------------------------------------

  this.leaveControl = function (direction) {

    this.state = this.NOTFOCUSED;
    this.clearFocus();
    $("body").trigger('controlEvent', ["leaveControl", null]);
    //$("body").trigger('keyPressed', [direction]);

  };

  // -----------------------------------------

  this.setFirstFocus = function () {

    $(".content", this.control).addClass("control-focus");

  };

  // -----------------------------------------

  this.clearFocus = function () {

    $(".control-focus", this.control).removeClass("control-focus");

  };

  // -----------------------------------------

  this.moveLeft = function () {

    this.leaveControl("left");

  };

  // -----------------------------------------

  this.moveRight = function () {

    this.leaveControl("right");

  };

  // -----------------------------------------

  this.moveUp = function () {

  };

  // -----------------------------------------

  this.moveDown = function () {

  };

  // -----------------------------------------

  this.createContent = function (data, datum) {

    this.control.append(this.content(data, datum));

  };

  // -----------------------------------------

  this.updateContent = function (data) {

    $(".content", this.control).remove();
    this.control.append(this.content(data, null));

  }

  // -----------------------------------------

  this.content = function (dataMatch, dataService) {

    var content = $("<div />").addClass("content");

    //  var date = new Date(data.datum);
    //  date.Format("dd. mmmm yyyy HH:MM");data.datum
    // Date.format(date,"dd. mmmm yyyy HH:MM");

    var title = "";

    if (dataService != null) {
      this.datum = dataService.MatchStart;
      title = $("<div />").addClass("title").text(dataService.MatchStart);
    }
    else {
      title = $("<div />").addClass("title").text(this.datum);
    }

    var team_1_goal = "";
    var team_2_goal = "";
    var score = "";

    if (dataMatch != null) {
      team_1_goal = dataMatch.team_1_goal;
      team_2_goal = dataMatch.team_2_goal;

      if (team_1_goal == "" || team_1_goal == null || team_1_goal == undefined)
        team_1_goal = "0";

      if (team_2_goal == "" || team_2_goal == null || team_2_goal == undefined)
        team_2_goal = "0";

      score = $("<div />").addClass("score").html(team_1_goal + " : " + team_2_goal);

    }

    if (dataService != null) {
      //Main.log("dataService.Team1Image " + dataService.Team1Image);
      this.Team1Image = dataService.Team1Image.replace("/41/", "/100_100/");
      this.Team2Image = dataService.Team2Image.replace("/41/", "/100_100/");
      this.Team1 = dataService.Team1;
      this.Team2 = dataService.Team2;
      this.UpdateTimespan = dataService.UpdateTimespan;
    }

    //this.Team1Image = "Theme/FCBayern/Images/TestLogo1.png";
    //this.Team2Image = "Theme/FCBayern/Images/TestLogo2.png";

    var logoteam1Container = $("<div />").addClass("logoteam1Container");
    var logoteam2Container = $("<div />").addClass("logoteam2Container");

    logoteam1Container.append($("<img />").addClass("logoteam1").attr("src", this.Team1Image));
    logoteam2Container.append($("<img />").addClass("logoteam1").attr("src", this.Team2Image));

    var team1 = $("<div />").addClass("team1").html(this.Team1);
    var team2 = $("<div />").addClass("team2").html(this.Team2);

    content.append(title);
    content.append(score);
    content.append(logoteam1Container);
    content.append(logoteam2Container);
    content.append(team1);
    content.append(team2);

    return content

  };

  // -----------------------------------------

}



