﻿
// ---- MENU -------------------------------------

MenuContainer = {

  control: new Array()

};

$(document).ready(function () {

  $("body").bind("initMenuControls", function (event, message) {

    $("div[iscontrol=true][controltype=menu]").each(function (index, item) {

      var name = $(item).attr("Id");
      name = new ControlMenu(name);
      MenuContainer.control[$(item).attr("Id")] = name;
      name.init();

      $("body").trigger('subControlCreated', [$(item).attr("Id"), $(item).attr("parent")]);

    });

  });

});

// constructor ---------------------------------------

function ControlMenu(controlId) {

  this.controlId = controlId;
  this.control = $("#" + controlId);
  this.state = this.NOTFOCUSED;
  this.FOCUSED = 1;
  this.NOTFOCUSED = 2;
  this.visibleItemsCount = 11;
  this.lastFocus = 0;
  this.currentFocus = 0;

  // -----------------------------------------

  this.init = function () {

    //Main.log(controlId + " init");

    var _this = this;

    //----

    $(this.control).bind("focusSet", function (event, element) {

      $("body").trigger('menuSetFocus', [null]);
      _this.takeControl();

    });

    //----

    $("body").bind("enterKeyPressed" + this.controlId, function (event, controlId) {

      if (_this.controlId != controlId)
        return;

      if (_this.state != _this.FOCUSED) {
        ////Main.log("enter pressed in: " + controlId);
        //    _this.state = _this.FOCUSED;
        //    $("body").trigger('controlEvent', ["takeControl", _this.controlId]);
        //    _this.setFirstFocus();
      } else {

      }

    });

    //----

    $("body").bind("controlKeyPressed" + this.controlId, function (event, direction, controlId) {

      if (_this.controlId != controlId)
        return;

      //Main.log("control " + controlId + " keyPressed " + direction);

      if (_this.state == _this.FOCUSED) {

        switch (direction) {
          case "up":
            _this.moveUp();
            break;
          case "down":
            _this.moveDown();
            break;
          case "left":
            _this.moveLeft();
            break;
          case "right":
            _this.moveRight();
            break;
          case "enter":

            var focused = $("li.controlFocus", this.control);
            _this.createSelectedItem();
            _this.leaveControl();
            $("body").trigger('menuEnterPressed', [focused.attr("cat"), focused.attr("item"), focused.attr("itemType"), false]);
            break;
          case "return":
            _this.leaveControl();
            $("body").trigger('menuReturnPressed', [null]);
            _this.deinit();
            break;
        }
      }

    });

  };

  // -----------------------------------------

  this.getControlName = function () {
    return controlId;
  };

  // -----------------------------------------

  this.deinit = function () {

    this.hide();
    this.control.html("");
    this.leaveControl();

  };

  // -----------------------------------------

  this.hide = function () {

    this.control.hide();

  };

  // -----------------------------------------

  this.show = function () {

    this.control.show();

  };

  // -----------------------------------------

  this.takeControl = function () {

    //Main.log("control " + this.controlId + " takeControl");

    this.state = this.FOCUSED;
    this.setFirstFocus();
    $("body").trigger('controlEvent', ["takeControl", this.controlId]);
  };

  // -----------------------------------------

  this.leaveControl = function (direction) {

    //Main.log("control " + this.controlId + " leaveControl");

    this.state = this.NOTFOCUSED;
    this.clearFocus();
    $("body").trigger('controlEvent', ["leaveControl", null]);
    //$("body").trigger('keyPressed', [direction]);

  };

  // -----------------------------------------

  this.setFirstFocus = function () {

    //$("li:eq(0)", this.control).addClass("controlFocus");
    //Main.log("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! " + this.lastFocus);
    $("li:eq(" + this.lastFocus + ")", this.control).addClass("controlFocus");

  };

  // -----------------------------------------

  this.createSelectedItem = function () {

    this.state = this.NOTFOCUSED;
    
    var focused = $("li.controlFocus", this.control);
    $("div.selected", this.control).removeClass("selected");
    $("div", focused).addClass("selected");
    this.lastFocus = this.currentFocus;
    this.clearFocus();

  };

  // -----------------------------------------

  this.clearFocus = function () {

    $(".controlFocus", this.control).removeClass("controlFocus");

  };

  // -----------------------------------------

  this.moveLeft = function () {

    this.lastFocus = this.currentFocus;
    this.clearFocus();
    $("body").trigger('menuFocusMove', ["left"]);
    

  };

  // -----------------------------------------

  this.moveRight = function () {

  };

  // -----------------------------------------

  this.moveUp = function () {

    if ($("li.controlFocus", this.control).prev().length == 0 && $("li.controlFocus", this.control).parent().parent().prev().length == 0) {
      return;
    }

    if ($("li.controlFocus", this.control).prev().length == 0) {

      if ($(".menuGroup, .dataProvider", $("li.controlFocus", this.control).parent().parent().prev()).attr("menuable") == "false") {

        $(".menuGroup, .dataProvider ", $("li.controlFocus", this.control).parent().parent().prev()).css("display", "block").attr("menuable", "true");


        var count = $("[menuable=false]", $("li.controlFocus", this.control).parent().parent().prev()).length + 1;
        //Main.log("count: " + count)

        $("[menuable=true]", this.control).each(function (index, item) {

          if (count > 0) {
            $("[menuable=true]", this.control).last().css("display", "none").attr("menuable", "false");
          }
          count--;
        });
      }

      $("li", $("li.controlFocus", this.control).removeClass("controlFocus").parent().parent().prev())
            .css("display", "block").attr("menuable", "true")
            .last()
            .addClass("controlFocus");

      this.currentFocus--;
      return;
    }

    this.currentFocus--;
    $("li.controlFocus", this.control).removeClass("controlFocus").prev().addClass("controlFocus");
    this.lastFocus = this.currentFocus;

  };

  // -----------------------------------------

  this.moveDown = function () {

      if ($("li.controlFocus", this.control).next().length == 0 && $("li.controlFocus", this.control).parent().parent().next().length == 0) {
          return;
      }

      if ($("li.controlFocus", this.control).next().length == 0) {

        if ($(".menuGroup, .dataProvider", $("li.controlFocus", this.control).parent().parent().next()).first().attr("menuable") == "false") {

          $(".menuGroup, .dataProvider", $("li.controlFocus", this.control).parent().parent().next()).first().css("display", "block").attr("menuable", "true");
          $("[menuable=true]", this.control).first().css("display", "none").attr("menuable", "false");
                //Main.log("next div ist hide");
             }

          $("li:eq(0)", $(".controlFocus", this.control).removeClass("controlFocus").parent().parent().next()).addClass("controlFocus");

          //Main.log("next div ist hide");

          if ($(".controlFocus", this.control).attr("menuable") == "false") {
            $(".controlFocus", this.control).css("display", "block").attr("menuable", "true");
            $("[menuable=true]", this.control).first().css("display", "none").attr("menuable", "false");
          }

          this.currentFocus++;
          return;
      }

        if ($(".controlFocus", this.control).next().attr("menuable") == "false") {
          $("[menuable=true]", this.control).last().next().css("display", "block").attr("menuable", "true");
          $("[menuable=true]", this.control).first().css("display", "none").attr("menuable", "false");
      }

      this.currentFocus++;
      $("li.controlFocus", this.control).removeClass("controlFocus").next().addClass("controlFocus");
      this.lastFocus = this.currentFocus;

  };

  // -----------------------------------------

  this.createMenuContent = function (items) {

    var _this = this;

    var menu = $("<div />").addClass("menuContainer");

    var itemsCounter = 0;

    //Main.log("createMenuContent");

    $(items).each(function (index, item) {

      //Main.log(item.Title + " " + index);

      itemsCounter++;

      var categorie = $("<div />");
      var menuGroupTitle = $("<div />").addClass("menuGroup").html(item.Title)

      if (itemsCounter < _this.visibleItemsCount) {
        menuGroupTitle.css("display", "block").attr("menuable", "true");
      } else {
        menuGroupTitle.css("display", "none").attr("menuable", "false");
      }

      categorie.html(menuGroupTitle);

      var menuItems = $("<ul />");

      switch (item.TypeAsString) {
        case "DataProvider":

          var menuItem = $("<li />");
          var _item = $("<div />").html(item.Title);
          menuItem.html(_item);
          menuItem.attr("cat", index);
          menuItem.attr("item", 0);
          menuItem.attr("itemType", "DataProvider");
          menuItems.append(menuItem);

          if (itemsCounter < _this.visibleItemsCount) {
            menuItem.css("display", "block").attr("menuable", "true");
          } else {
            menuItem.css("display", "none").attr("menuable", "false");
          }

          itemsCounter++;

          break;
        case "MenuGroup":

          $(item.Items).each(function (subIndex, subItem) {

            var menuItem = $("<li />");
            var _item = $("<div />").html(subItem.Title);
            menuItem.html(_item);
            menuItem.attr("cat", index);
            menuItem.attr("item", subIndex);
            menuItem.attr("itemType", "MenuGroup");
            menuItems.append(menuItem);

            if (itemsCounter < _this.visibleItemsCount) {
              menuItem.css("display", "block").attr("menuable", "true");
            } else {
              menuItem.css("display", "none").attr("menuable", "false");
            }

            itemsCounter++;

          });

          break;
      }

      categorie.append(menuItems);

      menu.append(categorie);

    });

    this.control.append(menu);

  };

// -----------------------------------------

  this.doDefaultAction = function () {

    //Main.log("Menu doDefaultAction()");

    //this.state = this.FOCUSED;
    //$("body").trigger('controlEvent', ["takeControl", this.controlId]);
    //this.setFirstFocus();

    var params = $("li.controlFocus", this.control);
    $("body").trigger('menuEnterPressed', [params.attr("cat"), params.attr("item"), params.attr("itemType"), true]);

    //$("body").trigger('keyPressed', ["enter"]);

  };

// -----------------------------------------

}


