﻿
// ---- NEWSENTRIES -------------------------------------

NewsEntriesContainer = {

  control: new Array()

};

$(document).ready(function () {

  $("body").bind("initNewsControls", function (event, message) {

    $("div[iscontrol=true][controltype=newsEntries]").each(function (index, item) {

      var name = $(item).attr("Id");
      name = new ControlNewsEntries(name);
      NewsEntriesContainer.control[$(item).attr("Id")] = name;
      name.init();

      $("body").trigger('subControlCreated', [$(item).attr("Id"), $(item).attr("parent")]);

    });

  });

});

// constructor ---------------------------------------

function ControlNewsEntries(controlId) {

  this.controlId = controlId;
  this.control = $("#" + controlId);
  this.state = this.NOTFOCUSED;
  this.FOCUSED = 1;
  this.NOTFOCUSED = 2;
  this.rowHeight = 75;
  this.selectedRow = 0;

  // -----------------------------------------

  this.init = function () {

    //Main.log(controlId + " init");

    var _this = this;

    //----

    $("body").bind("enterKeyPressed" + this.controlId, function (event, message) {

      if (_this.controlId != controlId)
        return;

    });

    //----

    $(this.control).bind("focusSet", function (event, element) {

      _this.state = _this.FOCUSED;
      _this.scrolerShow();
      $("body").trigger('controlEvent', ["takeControl", _this.controlId]);
      _this.setFirstFocus(_this.selectedRow);

    });

    //----

    $("body").bind("controlKeyPressed" + this.controlId, function (event, direction, controlId) {

      if (_this.controlId != controlId)
        return;

      if (_this.state == _this.FOCUSED) {

        switch (direction) {
          case "up":
            _this.moveUp();
            break;
          case "down":
            _this.moveDown();
            break;
          case "left":
            _this.moveLeft();
            break;
          case "right":
            _this.moveRight();
            break;
          case "enter":
            _this.scrolerHide();
            $("body").trigger('newsEntriesEnterPressed', [$(".control-focus", _this.control).attr("title")]);
            _this.state = _this.NOTFOCUSED;
            _this.clearFocus();
            break;
          case "return":
            _this.leaveControl();
            _this.deinit();
            $("body").trigger('newsEntriesReturnPressed', [null]);
            break;
        }
      }

    });

    //----

  };

  // -----------------------------------------

  this.getControlName = function () {
    return controlId;
  };

  // -----------------------------------------

  this.deinit = function () {

    $(this.control).unbind("focusSet");
    $("body").unbind("enterKeyPressed" + this.controlId);
    $("body").unbind("controlKeyPressed" + this.controlId);

    this.hide();
    this.control.html("");

  };

  // -----------------------------------------

  this.hide = function () {

    this.control.hide();

  };

  // -----------------------------------------

  this.show = function () {

    this.control.show();

  };

  // -----------------------------------------

  this.takeControl = function () {
    this.state = this.FOCUSED;
    this.setFirstFocus(this.selectedRow);
    $("body").trigger('controlEvent', ["takeControl", this.controlId]);
  };

  // -----------------------------------------

  this.leaveControl = function (direction) {

    this.state = this.NOTFOCUSED;
    this.clearFocus();
    this.scrolerHide();
    $("body").trigger('controlEvent', ["leaveControl", null]);
    //$("body").trigger('keyPressed', [direction]);

  };

  // -----------------------------------------

  this.setFirstFocus = function (index) {

    //Main.log("NewsEntries setFirstFocus");

    $("#" + this.controlId + " .rows>div:eq(" + index + ")").addClass("control-focus");

  };

  // -----------------------------------------

  this.clearFocus = function () {

    $(".control-focus", this.control).removeClass("control-focus");

  };

  // -----------------------------------------

  this.moveLeft = function () {

    this.leaveControl("left");

  };

  // -----------------------------------------

  this.moveRight = function () {


  };

  // -----------------------------------------

  this.moveUp = function () {
	  
    if ($(".control-focus", this.control).prev().length == 0) {
      return;
    }

    var top = $(".rows", this.control).position().top;
    var top2 = $(".control-focus", this.control).prev().position().top;

    var height = $(".rows", this.control).height();
    var height2 = $(".rowsContainer", this.control).height();

    var scrolerbarheight = $(".scrolerBarNewsEntries", this.control).height();
    var scrolerheight = $(".scrolerNewsEntries", this.control).height();

    //Main.log("top: " + top);
    //Main.log("top2: " + top2);
    //Main.log("delta: " + (top + top2));
    //Main.log("height: " + height);
    //Main.log("height2: " + height2);
    //Main.log("scrolerbarheight: " + scrolerbarheight);
    //Main.log("scrolerheight: " + scrolerheight);
    //Main.log("this.rowHeight " + this.rowHeight);
    
    if (top + top2 < 0) {

      $(".rows", this.control).css("top", $(".rows", this.control).position().top + this.rowHeight);
      $(".scrolerNewsEntries", this.control).css("top", ($(".scrolerNewsEntries", this.control).position().top - Math.ceil((scrolerbarheight - scrolerheight) / ((height - height2) / this.rowHeight))));
    }

    this.selectedRow--;

    $(".control-focus", this.control).removeClass("control-focus").prev().addClass("control-focus");

  };

  // -----------------------------------------

  this.moveDown = function () {

    if ($(".control-focus", this.control).next().length == 0) {
      return;
    }

    var top = $(".rows", this.control).position().top;
    var top2 = $(".control-focus", this.control).next().position().top;

    var height = $(".rows", this.control).height();
    var height2 = $(".rowsContainer", this.control).height();

    var scrolerbarheight = $(".scrolerBarNewsEntries", this.control).height();
    var scrolerheight = $(".scrolerNewsEntries", this.control).height();

    //Main.log("top: " + top);
    //Main.log("top2: " + top2);
    //Main.log("delta: " + (top + top2));
    //Main.log("height: " + height);
    //Main.log("height2: " + height2);
    //Main.log("scrolerbarheight: " + scrolerbarheight);
    //Main.log("scrolerheight: " + scrolerheight);
    //Main.log("this.rowHeight: " + this.rowHeight);
    //Main.log("step count: " + (height2 - height) / this.rowHeight);
    //Main.log("step : " + (scrolerbarheight - scrolerheight) / ((height - height2) / this.rowHeight));
    //Main.log("step round: " + Math.ceil((scrolerbarheight - scrolerheight) / ((height - height2) / this.rowHeight)));

    if (top + top2 > 4 * this.rowHeight - 1) {
      $(".rows", this.control).css("top", $(".rows", this.control).position().top - this.rowHeight);
      $(".scrolerNewsEntries", this.control).css("top", ($(".scrolerNewsEntries", this.control).position().top + Math.ceil((scrolerbarheight - scrolerheight) / ((height - height2) / this.rowHeight))));
  }

  //Main.log("scroler top : " + $(".scrolerNewsEntries", this.control).position().top);

    this.selectedRow++;

    $(".control-focus", this.control).removeClass("control-focus").next().addClass("control-focus");

  };

  // -----------------------------------------

  this.createContent = function (data) {

    var rowsContainer = $("<div />").addClass("rowsContainer");
    var rows = $("<div />").addClass("rows");

    var i = 0;
    $(data).each(function (index, item) {

      //var row = $("<div />").addClass("row").attr("title", i);
      var row = $("<div />").attr("title", i);

      var date = $("<div />").addClass("news-row-pdate").html(item.PubDate);
      var img = $("<img />").attr("src", item.ThumbnailUrl);
      var iBorder = $("<div />").addClass("news-row-imgBorder");
      var ttitle = $("<div />").addClass("news-row-title").html(item.Title);
      //  var tdate = $("<div />").addClass("news-row-date").html(item.PubDate);
      var tdescription = $("<div />").addClass("news-row-desc").html(item.Description.substring(0, 70));

      row.append(date);
      row.append(img);
      row.append(ttitle);
      row.append(iBorder);
      //   row.append(tdate);
      row.append(tdescription);

      rows.append(row);

      i++;

    });

    rowsContainer.append(rows);
    this.control.append(rowsContainer);

  };

  // -----------------------------------------

  this.pressEnter = function () {

    this.scrolerHide();
    $("body").trigger('newsEntriesEnterPressed', [$(".control-focus", this.control).attr("title")]);
    this.state = this.NOTFOCUSED;
    this.clearFocus();

  };

  // -----------------------------------------

  this.doDefaultAction = function () {

    this.state = this.FOCUSED;
    $("body").trigger('controlEvent', ["takeControl", this.controlId]);
    this.setFirstFocus(this.selectedRow);

  };

  // -----------------------------------------

  this.scrolerShow = function () {
    $(".scrolerBarNewsEntries", this.control).show();
  }

  // -----------------------------------------

  this.scrolerHide = function () {
    $(".scrolerBarNewsEntries", this.control).hide();
  }

  // -----------------------------------------

  

}


