﻿
// ---- PLAYER -------------------------------------

PlayerContainer = {

  control: new Array()

};

$(document).ready(function () {

  $("body").bind("initMenuControls", function (event, message) {

    $("div[iscontrol=true][controltype=player]").each(function (index, item) {

      var name = $(item).attr("Id");
      name = new ControlPlayer(name);
      PlayerContainer.control[$(item).attr("Id")] = name;
      name.init();

      $("body").trigger('subControlCreated', [$(item).attr("Id"), $(item).attr("parent")]);

    });

  });

});

// constructor ---------------------------------------

function ControlPlayer(controlId) {

  this.controlId = controlId;
  this.control = $("#" + controlId);
  this.state = this.NOTFOCUSED;
  this.FOCUSED = 1;
  this.NOTFOCUSED = 2;
  this.videoUrl = null;
  this.STOP = 1;
  this.PLAYING = 2;
  this.PAUSSED = 3;
  this.NORMAL = 1;
  this.FULLSCREEN = 2;
  this.videoState = this.STOP;
  this.displayState = this.NORMAL;

  // -----------------------------------------

  this.init = function () {

    //Main.log(controlId + " init");

    var _this = this;

    //----

    $(this.control).bind("focusSet", function (event, element) {

      //Main.log("Player focus set !!!");

      $("body").trigger('playerSetFocus', [null]);
      _this.takeControl();

    });

    //----

    $(this.control).bind("enterKeyPressed", function (event, message) {

      //Main.log("enter pressed in: " + controlId);

      if (_this.state != _this.FOCUSED) {
        //_this.state = _this.FOCUSED;
        //$("body").trigger('controlEvent', ["takeControl", _this.controlId]);
        //_this.setFirstFocus();
      } else {

      }

    });

    //----

    $("body").bind("controlKeyPressed" + this.controlId, function (event, direction, controlId) {

      if (_this.controlId != controlId)
        return;

      //if (_this.state == _this.FOCUSED) {

      switch (direction) {
        case "up":
          _this.moveUp();
          break;
        case "down":
          _this.moveDown();
          break;
        case "left":
          _this.moveLeft();
          break;
        case "right":
          _this.moveRight();
          break;
        case "enter":
          //_this.state = _this.NOTFOCUSED;
          //_this.clearFocus();
          $("body").trigger('playerEnterPressed', [null]);
          break;
        case "return":
          _this.leaveControl("return");
          _this.deinit();
          $("body").trigger('playerReturnPressed', [null]);
          break;
      }

      //}

    });

    //----

  };

  // -----------------------------------------

  this.getControlName = function () {
    return controlId;
  };

  // -----------------------------------------

  this.deinit = function () {

    $(this.control).unbind("focusSet");
    $("body").unbind("enterKeyPressed" + this.controlId);
    $("body").unbind("controlKeyPressed" + this.controlId);

    this.hide();
    this.control.html("");

  };

  // -----------------------------------------

  this.hide = function () {

      $("#pluginObjectPlayer").css("visibility", "hidden");
      this.control.hide();

  };

  // -----------------------------------------

  this.show = function () {

      $("#pluginObjectPlayer").css("visibility", "visible");
    this.control.show();

  };

  // -----------------------------------------

  this.takeControl = function () {
    this.state = this.FOCUSED;
    this.setFirstFocus();
    $("body").trigger('controlEvent', ["takeControl", this.controlId]);
  };

  // -----------------------------------------

  this.leaveControl = function (direction) {

    this.state = this.NOTFOCUSED;
    this.clearFocus();
    $("body").trigger('controlEvent', ["leaveControl", null]);
    //$("body").trigger('keyPressed', [direction]);

  };

  // -----------------------------------------

  this.setFirstFocus = function () {

    //$(".controls div:eq(0)", this.control).addClass("control-focus");

  };

  // -----------------------------------------

  this.clearFocus = function () {

    //$(".control-focus", this.control).removeClass("control-focus");

  };

  // -----------------------------------------

  this.moveLeft = function () {


  };

  // -----------------------------------------

  this.moveRight = function () {

    this.leaveControl("right");

  };

  // -----------------------------------------

  this.moveUp = function () {

    this.leaveControl("up");

  };

  // -----------------------------------------

  this.moveDown = function () {

    this.leaveControl("down");

  };

  // -----------------------------------------

  this.play = function () {

      //Main.log("play video: " + this.videoUrl);

      this.videoState = this.PLAYING;

      Player.setVideoURL(this.videoUrl);
      Player.playVideo();

  };

  // -----------------------------------------

  this.pause = function () {

    //Main.log("pause video: " + this.videoUrl);

    this.videoState = this.PAUSSED;

    Player.pauseVideo();

  };

  // -----------------------------------------

  this.stop = function () {

    //Main.log("player stop");

    this.videoState = this.STOP;
    Player.Stop();

  };

  // -----------------------------------------

  this.setToFullscreen = function () {

    //Main.log("player stop");

    this.displayState = this.FULLSCREEN;

  };

  // -----------------------------------------

  this.setToFullScreen = function () {

    //Main.log("player setToFullscreen");

    this.displayState = this.NORMAL;

  };

  // -----------------------------------------

  this.setNormalScreen = function () {

    //Main.log("player setNormalScreen");

  };

  // -----------------------------------------

  this.setVideoUrl = function (url) {

    this.videoUrl = url;
  
    //$(".url", this.control).html("URL: " + this.videoUrl);
    this.displayStateHtml();

  };

  // -----------------------------------------

  this.getPlayerStateString = function () {

    var returnValue = "";

    switch (this.videoState) {
      case this.STOP:
        returnValue = "STOP";
        break;
      case this.PLAYING:
        returnValue = "PLAYING";
        break;
      case this.PAUSSED:
        returnValue = "PAUSSED";
        break;
      case this.NORMAL:
        returnValue = "NORMAL";
        break;
    }

    return returnValue;

  };

  // -----------------------------------------

  this.getSceenStateString = function () {

    var returnValue = "";

    switch (this.displayState) {
      case this.FULLSCREEN:
        returnValue = "FULLSCREEN";
        break;
      case this.NORMAL:
        returnValue = "NORMAL";
        break;
    }

    return returnValue;

  };

  // -----------------------------------------

  this.changeState = function (state) {

    switch (state) {
      case "play":
        this.videoState = this.PLAYING;
        break;
      case "pause":
        this.videoState = this.PAUSSED;
        break;
      case "stop":
        this.videoState = this.STOP;
        break;
      case "full":
        this.displayState = this.FULLSCREEN;
        break;
      case "normal":
        this.displayState = this.NORMAL;
        break;
    }

    this.displayStateHtml();

  };

  // -----------------------------------------

  this.displayStateHtml = function () {

    //$(".player-state", this.control).html("PLAYER STATE: " + this.getPlayerStateString());
    //$(".screen-state", this.control).html("SCREEN STATE: " + this.getSceenStateString());

  };

  // -----------------------------------------
  

}


