﻿
// ---- REMOTE -------------------------------------

RemoteContainer = {

  control: new Array()

};

$(document).ready(function () {

  $("body").bind("initMenuControls", function (event, message) {

    $("div[iscontrol=true][controltype=remote]").each(function (index, item) {

      var name = $(item).attr("Id");
      name = new ControlRemote(name);
      RemoteContainer.control[$(item).attr("Id")] = name;
      name.init();

      $("body").trigger('subControlCreated', [$(item).attr("Id"), $(item).attr("parent")]);

    });

  });

});

// constructor ---------------------------------------

function ControlRemote(controlId) {

  this.controlId = controlId;
  this.control = $("#" + controlId);
  this.state = this.NOTFOCUSED;
  this.FOCUSED = 1;
  this.NOTFOCUSED = 2;
  this.PLAY = 1;
  this.PAUSSED = 2;
  this.STOPED = 3;
  this.RESUME = 4;
  this.NORMAL = 3;
  this.FULLSCREEN = 4;
  this.playPauseState = this.STOPED;
  this.fullscreenNormalState = this.NORMAL;

  // -----------------------------------------

  this.init = function () {

    //Main.log(controlId + " init");

    var _this = this;

    //----

    $(this.control).bind("focusSet", function (event, element) {

      _this.show();
      _this.takeControl();

    });

    //----

    $(this.control).bind("enterKeyPressed", function (event, message) {

      if (_this.state != _this.FOCUSED) {
        ////Main.log("enter pressed in: " + controlId);
        //_this.state = _this.FOCUSED;
        //$("body").trigger('controlEvent', ["takeControl", _this.controlId]);
        //_this.setFirstFocus();
      } else {

      }

    });

    //----

    $("body").bind("controlKeyPressed" + this.controlId, function (event, direction, controlId) {

      if (_this.controlId != controlId)
        return;

      //Main.log("control " + controlId + " keyPressed " + direction);

      if (_this.state == _this.FOCUSED) {

        switch (direction) {
          case "up":
            _this.moveUp();
            break;
          case "down":
            _this.moveDown();
            break;
          case "left":
            _this.moveLeft();
            break;
          case "right":
            _this.moveRight();
            break;
          case "enter":
            _this.doAction();
            break;
          case "return":
            //Main.log("Remote return " + Player.display);
            if (Player.display != Player.FULLSCREEN) {
              _this.leaveControl();
              _this.deinit();
              $("body").trigger('remoteReturnPressed', [null]);
            } else {
              _this.doAction();
            }

            break;
        }
      }

    });

    //----

  };

  // -----------------------------------------

  this.getControlName = function () {
    return controlId;
  };

  // -----------------------------------------

  this.deinit = function () {

    this.hide();
    this.control.html("");

  };

  // -----------------------------------------

  this.hide = function () {

    $("body").trigger('remoteVisibilityStateChange', ["hide"]);
    this.control.hide();

  };

  // -----------------------------------------

  this.show = function () {

    $("body").trigger('remoteVisibilityStateChange', ["show"]);
    this.control.show();

  };

  // -----------------------------------------

  this.takeControl = function () {

    //Main.log("control " + this.controlId + " takeControl");

    this.state = this.FOCUSED;
    this.setFirstFocus();
    $("body").trigger('controlEvent', ["takeControl", this.controlId]);
  };

  // -----------------------------------------

  this.leaveControl = function (direction) {

    //Main.log("control " + this.controlId + " leaveControl");

    this.state = this.NOTFOCUSED;
    this.clearFocus();
    $("body").trigger('controlEvent', ["leaveControl", null]);
    $("body").trigger('remoteLeaveControl', [null]);

  };

  // -----------------------------------------

  this.setFirstFocus = function () {

    //Main.log("Remote setFirstFocus");

    this.clearFocus();
    $("#PlayerFull", this.control).addClass("controlFocus");

  };

  // -----------------------------------------

  this.clearFocus = function () {

    $(".controlFocus", this.control).removeClass("controlFocus");

  };

  // -----------------------------------------

  this.moveLeft = function () {

    //alert($(this.control).html());

    if (this.fullscreenNormalState == this.FULLSCREEN) {
      return;
    }

    if ($(".controlFocus", this.control).prev().length == 0) {
      return;
    }

    $(".controlFocus", this.control).removeClass("controlFocus").prev().addClass("controlFocus");


  };

  // -----------------------------------------

  this.moveRight = function () {

    if (this.fullscreenNormalState == this.FULLSCREEN) {
      return;
    }

    if ($(".controlFocus", this.control).next().length == 0) {
      this.leaveControl("right");
      return;
    }

    $(".controlFocus", this.control).removeClass("controlFocus").next().addClass("controlFocus");

  };

  // -----------------------------------------

  this.moveUp = function () {

    if (this.fullscreenNormalState == this.FULLSCREEN) {
      return;
    }

    //this.leaveControl("up");

  };

  // -----------------------------------------

  this.moveDown = function () {

    if (this.fullscreenNormalState == this.FULLSCREEN) {
      return;
    }

    this.leaveControl("down");

  };

  // -----------------------------------------

  this.createContent = function () {

    var buttons = $("<div />").addClass("controls"); ;

    var _play = $("<div />").attr("playerControl", "play").attr("title", "play").attr("id", "PlayerPlay").html($("<img />").attr("src", Main.setting.App.ImagePath + "Play.png"));
    var _stop = $("<div />").attr("playerControl", "stop").attr("title", "stop").attr("id", "PlayerStop").append($("<img />").attr("src", Main.setting.App.ImagePath + "Stop.png"));
    var _full = $("<div />").attr("playerControl", "full").attr("title", "full").attr("id", "PlayerFull").append($("<img />").attr("src", Main.setting.App.ImagePath + "FullScreen.png"));

    var timeline = $("<div />").attr("id", "timeline");
    var buffering = $("<div />").attr("id", "buffering");
    var bufferingInfo = $("<div />").addClass("bufferingInfo");
    var progress = $("<div />").addClass("progress");

    var time = $("<div />").attr("id", "timeInfo");

    var timeNow = $("<div />").addClass("time-current");
    var timeSeparator = $("<div />").addClass("time-separator");
    var timeTotal = $("<div />").addClass("time-total");

    time.append(timeNow);
    time.append(timeSeparator);
    time.append(timeTotal);

    buffering.append(bufferingInfo);
    timeline.append(progress);

    buttons.append(_play);
    buttons.append(_stop);
    buttons.append(_full);

    this.control.append(buttons);
    this.control.append(timeline);
    this.control.append(time);
    this.control.append(buffering);

  };

  // -----------------------------------------

  this.doAction = function () {

    var action = $(".controlFocus", this.control).attr("title");

    switch (action) {
      case "play":
      case "pause":
        if (this.playPauseState == this.PLAY) {
          this.playPauseState = this.PAUSSED;
        } else if (this.playPauseState == this.PAUSSED) {
          this.playPauseState = this.RESUME;
        } else if (this.playPauseState == this.STOPED) {
          this.playPauseState = this.PLAY;
        }
        this.changePlayingState();
        break;
      case "stop":
        this.playPauseState = this.STOPED;
        this.changePlayingState();
        break;
      case "full":
        this.fullscreenNormalState = this.FULLSCREEN;
        this.changeDisplayState();
        break;
      case "normal":
        this.fullscreenNormalState = this.NORMAL;
        this.changeDisplayState();
        break;
    }
    
  };

  // -----------------------------------------

  this.changePlayingState = function () {

    if (this.playPauseState == this.RESUME) {
      $("body").trigger('remoteAction', ["resume"]);
      this.playPauseState = this.PLAY;
    }

    if (this.playPauseState == this.STOPED) {
      $("body").trigger('remoteAction', ["stop"]);
    }

    if (this.playPauseState == this.PLAY) {
      $("[playerControl=playme]", this.control).attr("title", "pause");
      $("body").trigger('remoteAction', ["play"]);
    }

    if (this.playPauseState == this.PAUSSED) {
      $("[playerControl=playme]", this.control).attr("title", "play");
      $("body").trigger('remoteAction', ["pause"]);
    }

  };

  // -----------------------------------------

  this.changeDisplayState = function () {

    if (this.fullscreenNormalState == this.FULLSCREEN) {
      $("[playerControl=full]", this.control).attr("title", "normal");
      $("body").trigger('remoteAction', ["fullscreen"]);
    }

    if (this.fullscreenNormalState == this.NORMAL) {
      $("[playerControl=full]", this.control).attr("title", "full");
      $("body").trigger('remoteAction', ["screenbox"]);
    }

  };

  // -----------------------------------------

  this.doIsPlaying = function (isPlaying) {

    if (isPlaying) {
      this.playPauseState = this.PLAY;
      $("[playerControl=playme]", this.control).html("").attr("title", "pause");
    } else {
      this.playPauseState = this.PAUSSED;
      $("[playerControl=playme]", this.control).html("").attr("title", "play");
    }

  };

  // -----------------------------------------

  

}



