﻿
// ----SPLASH -------------------------------------

SplashContainer = {

    control: new Array()

};

$(document).ready(function () {

    $("body").bind("initControls", function (event, message) {

        $(".splash.control").each(function (index, item) {

            var name = $(item).attr("Id");
            name = new ControlSplash(name);
            SplashContainer.control[$(item).attr("Id")] = name;
            name.init();

            $("body").trigger('controlCreated', [null]);

        });

    });

});

// constructor ---------------------------------------

function ControlSplash(controlId) {

    this.controlId = controlId;
    this.control = $("#" + controlId);
    this.state = this.NOTFOCUSED;
    this.FOCUSED = 1;
    this.NOTFOCUSED = 2;
    this.currentFocusIndex = 1;
    this.lastFocus = 1;
    this.splashCount = 0;

    // -----------------------------------------

    this.init = function () {

        //Main.log(controlId + " init");

        var _this = this;

        //----

        $("body").bind("controlKeyPressed" + this.controlId, function (event, direction, controlId) {

            if (_this.controlId != controlId)
                return;

            if (_this.state == _this.FOCUSED) {
                switch (direction) {
                    case "up":
                        break;
                    case "down":
                        break;
                    case "left":
                        _this.moveLeft();
                        break;
                    case "right":
                        _this.moveRight();
                        break;
                    case "enter":
                        $("body").trigger('splashBoxPressed', [$(".control-focus", _this.control).attr("title")]);
                        break;
                    case "return":
                        $("body").trigger('splashReturnPresed', [null]);
                        break;
                }
            }

        });

        //----

    };

    // -----------------------------------------

    this.deinit = function () {

    };

    // -----------------------------------------

    this.getControlName = function () {
        return controlId;
    };

    // -----------------------------------------

    this.hide = function () {

        this.control.hide();

    };

    // -----------------------------------------

    this.show = function () {

        this.control.show();

    };

    // -----------------------------------------

    this.takeControl = function () {
        this.state = this.FOCUSED;
        //this.setFirstFocus();
        $("body").trigger('controlEvent', ["takeControl", this.controlId]);
    };

    // -----------------------------------------

    this.leaveControl = function (direction) {

        this.lastFocus = this.currentFocusIndex;
        this.state = this.NOTFOCUSED;
        //this.clearFocus();
        $("body").trigger('keyPressed', [direction]);
        $("body").trigger('controlEvent', ["leaveControl", null]);
        this.deinit();

    };

    // -----------------------------------------

    this.setFirstFocus = function () {
        this.currentFocusIndex = this.lastFocus;
        $("[splashbox]:eq(" + this.lastFocus + ")", this.control).addClass("control-focus");
    };

    // -----------------------------------------

    this.clearFocus = function () {

        $(".control-focus", this.control).removeClass("control-focus");

    };

    // -----------------------------------------

    this.moveLeft = function () {


        $(".control-focus").removeClass("control-focus");

        if (this.currentFocusIndex == 0) {
            this.currentFocusIndex = this.splashCount - 1;
        } else {
            this.currentFocusIndex--;
        }

        $("[splashbox]", this.control).eq(this.currentFocusIndex).addClass("control-focus");

    };

    // -----------------------------------------

    this.moveRight = function () {


        $(".control-focus").removeClass("control-focus");

        if (this.currentFocusIndex == this.splashCount - 1) {
            this.currentFocusIndex = 0;
        } else {
            this.currentFocusIndex++;
        }

        $("[splashbox]", this.control).eq(this.currentFocusIndex).addClass("control-focus");

    };

    // -----------------------------------------

}


