﻿
// ---- TICKER -------------------------------------

TickerContainer = {

  control: new Array()

};

$(document).ready(function () {

  $("body").bind("initMatchControls", function (event, message) {

    $("div[iscontrol=true][controltype=ticker]").each(function (index, item) {

      var name = $(item).attr("Id");
      name = new ControlTicker(name);
      TickerContainer.control[$(item).attr("Id")] = name;
      name.init();

      $("body").trigger('subControlCreated', [$(item).attr("Id"), $(item).attr("parent")]);

    });

  });

});

// constructor ---------------------------------------

function ControlTicker(controlId) {

  this.controlId = controlId;
  this.control = $("#" + controlId);
  this.state = this.NOTFOCUSED;
  this.FOCUSED = 1;
  this.NOTFOCUSED = 2;
  this.selected = 0;
  this.lastId = null;

  // -----------------------------------------

  this.init = function () {

    //Main.log(controlId + " init");

    var _this = this;

    //----

    $(this.control).bind("enterKeyPressed", function (event, message) {

      //Main.log("enter pressed in: " + controlId);

      if (_this.state != _this.FOCUSED) {
        _this.state = _this.FOCUSED;
        $("body").trigger('controlEvent', ["takeControl", _this.controlId]);
        //_this.setFirstFocus(_this.selected);
      } else {

      }

    });

    //----

    $(this.control).bind("focusSet", function (event, message) {

      _this.doDefaultAction();

    });

    //----

    $("body").bind("controlKeyPressed" + this.controlId, function (event, direction, controlId) {

      if (_this.controlId != controlId)
        return;

      if (_this.state == _this.FOCUSED) {

        switch (direction) {
          case "up":
            _this.moveUp();
            break;
          case "down":
            _this.moveDown();
            break;
          case "left":
            _this.moveLeft();
            break;
          case "right":
            _this.moveRight();
            break;
          case "enter":
            //_this.state = _this.NOTFOCUSED;
            //_this.clearFocus();
            //$("body").trigger('remoteEnterPressed', [null]);
            break;
          case "return":
            _this.leaveControl();
            _this.deinit();
            $("body").trigger('tickerReturnPressed', [null]);
            break;
        }
      }

    });

    //----

  };

  // -----------------------------------------

  this.getControlName = function () {
    return controlId;
  };

  // -----------------------------------------

  this.deinit = function () {

    this.hide();
    this.control.html("");

  };

  // -----------------------------------------

  this.hide = function () {

    this.control.hide();

  };

  // -----------------------------------------

  this.show = function () {

    this.control.show();

  };

  // -----------------------------------------

  this.takeControl = function () {

    //Main.log("Ticker.takeControl()");

    this.state = this.FOCUSED;
    this.setFirstFocus(this.selected);
    $("body").trigger('controlEvent', ["takeControl", this.controlId]);
  };

  // -----------------------------------------

  this.leaveControl = function (direction) {

    this.state = this.NOTFOCUSED;
    this.clearFocus();
    $("body").trigger('controlEvent', ["leaveControl", null]);
    //$("body").trigger('keyPressed', [direction]);

    //Main.log("xxxxxxxxxxxxxxx " + this.state);

  };

  // -----------------------------------------

  this.setFirstFocus = function (index) {

    this.clearFocus();

    //Main.log("ticker setFirstFocus index: " + index + " " + this.controlId);
    // $("#" + this.controlId + " .rows>div:eq(" + index + ")").addClass("control-focus");
    
    $("#" + this.controlId + " .rows>div:eq(" + 0 + ")").addClass("control-focus");
    $(".rows", this.control).css('top', 0);

  };

  // -----------------------------------------

  this.clearFocus = function () {

    $(".control-focus", this.control).removeClass("control-focus");

  };

  // -----------------------------------------

  this.moveLeft = function () {

    this.leaveControl("left");

  };

  // -----------------------------------------

  this.moveRight = function () {

    this.leaveControl("right");

  };

  // -----------------------------------------

  this.moveUp = function () {

    if ($("#" + this.controlId + " .control-focus").prev().length == 0) {
      return;
    }

    var heightRow = $("#" + this.controlId + " .control-focus").prev().height();
    //Main.log("height realy: " + heightRow);
    heightRow = Math.ceil(heightRow);
    var topRows = $(".rows", this.control).position().top;

    ////Main.log("height : " + heightRow);
    ////Main.log("topRows : " + topRows);
    ////Main.log("new top : " + (topRows + heightRow));

    $(".rows", this.control).css('top', topRows + heightRow);

    $("#" + this.controlId + " .control-focus").removeClass("control-focus").prev().addClass("control-focus");

    this.selected--
  };

  // -----------------------------------------

  this.moveDown = function () {

    if ($("#" + this.controlId + " .control-focus").next().length == 0) {
      return;
    }

    var heightRow = $("#" + this.controlId + " .control-focus").height();
    //Main.log("height realy: " + heightRow);
    heightRow = Math.ceil(heightRow);
    var topRows = $(".rows", this.control).position().top;

    ////Main.log("height : " + heightRow);
    ////Main.log("topRows : " + topRows);
    ////Main.log("new top : " + (topRows - heightRow));

    $(".rows", this.control).css('top', topRows - heightRow);

    $(".control-focus", this.control).removeClass("control-focus").next().addClass("control-focus");

    this.selected++;
  };

  // -----------------------------------------

  this.createContent = function (data) {

    var _this = this;

    var rowsContainer = $("<div />").addClass("rows-container");
    var rows = $("<div />").addClass("rows");

    $(data.kommentar).each(function (index, item) {


      if (index == 0)
        _this.lastId = item.id;

      var row = $("<div />");

      var title = $("<div />").addClass("title").html(item.time);
      var description = $("<div />").addClass("description").html(item.text);
      var helper = $("<div />").addClass("helper");

      row.append(description);
      row.append(title);
      row.append(helper);

      rows.append(row);

    });

    rowsContainer.append(rows);

    this.control.append(rowsContainer);
    this.setFirstFocus(0);

  };

  // -----------------------------------------

  this.updateContent = function (data) {

    var _this = this;

    //Main.log("ticker updateContent....");

    $(data.kommentar).each(function (index, item) {

      if (item.id > _this.lastId) {

        _this.lastId = item.id;

        var row = $("<div />");
        var title = $("<div />").addClass("title").html(item.time);
        var description = $("<div />").addClass("description").html(item.text);
        var helper = $("<div />").addClass("helper");

        row.append(description);
        row.append(title);
        row.append(helper);

        $(".rows", _this.control).prepend(row);

        //Main.log("----------------------------------- " + _this.state);

        if (_this.state == _this.FOCUSED) {
          _this.setFirstFocus(0);
          _this.takeControl();
        } else {
          $(".rows", this.control).css('top', 0);
        }

      } else {


        //Main.log("----------------------------------- " + _this.state);

        if (_this.state == _this.FOCUSED) {
          _this.setFirstFocus(0);
        } else {
          $(".rows", this.control).css('top', 0);
        }

        return false;
      }

    });

  }

  // -----------------------------------------

  this.doDefaultAction = function () {

    //Main.log("ticker do default");

    this.state = this.FOCUSED;
    $("body").trigger('controlEvent', ["takeControl", this.controlId]);
    this.setFirstFocus(this.selected);

  };

  // -----------------------------------------

}


