﻿// ----WEBRADIO -------------------------------------

WebradioContainer = {

  control: new Array()

};

$(document).ready(function () {

  $("body").bind("initMatchControls", function (event, message) {

    $("div[iscontrol=true][controltype=webradio]").each(function (index, item) {

      var name = $(item).attr("Id");
      name = new ControlWebradio(name);
      WebradioContainer.control[$(item).attr("Id")] = name;
      name.init();

      $("body").trigger('subControlCreated', [$(item).attr("Id"), $(item).attr("parent")]);

    });

  });

});

// constructor ---------------------------------------

function ControlWebradio(controlId) {

  this.controlId = controlId;
  this.control = $("#" + controlId);
  this.state = this.NOTFOCUSED;
  this.FOCUSED = 1;
  this.NOTFOCUSED = 2;

  this.isStreamStarted = false;
  this.isEnabled = false;

  // -----------------------------------------

  this.init = function () {

    //Main.log(controlId + " init");

    var _this = this;

    //----

    $(this.control).bind("focusSet", function (event, message) {

      //Main.log("Webradio focus set");

      if (_this.isEnabled) {
        _this.takeControl();
        _this.setFirstFocus();
      } else {
        $("body").trigger('webradioNotAllowed', [null]);
      }

    });

    //----

    $("body").bind("controlKeyPressed" + this.controlId, function (event, direction, controlId) {

      if (_this.controlId != controlId)
        return;

      //Main.log(_this.controlId + " controlKeyPressed " + controlId + " " + direction);

      if (_this.state == _this.FOCUSED) {
        switch (direction) {
          case "up":
            break;
          case "down":
            break;
          case "left":
            _this.leaveControl(direction);
            //_this.deinit();
            break;
          case "right":
            _this.leaveControl(direction);
            //_this.deinit();
            break;
          case "enter":
            _this.isStreamStarted = true;
            $("body").trigger('webradioEnterPressed', [null]);
            break;
          case "return":
            $("body").trigger('webradioReturnPressed', [null]);
            _this.leaveControl();
            _this.deinit();
            break;
        }
      }
    });

  };

  // -----------------------------------------

  this.deinit = function () {

    $(this.control).unbind("focusSet");
    $("body").unbind("controlKeyPressed" + this.controlId);

    this.hide();
    this.control.html("");

    this.leaveControl();

  };

  // -----------------------------------------

  this.getControlName = function () {
    return controlId;
  };

  // -----------------------------------------

  this.hide = function () {

    this.control.hide();

  };

  // -----------------------------------------

  this.show = function () {

    this.control.show();

  };

  // -----------------------------------------

  this.create = function (webradioUrl) {

    if (webradioUrl != null) {
      this.isEnabled = true;
      this.show();
    }
    else {
      this.isEnabled = false;
    }

  };

  // -----------------------------------------

  this.clearFocus = function () {

    $(".control-focus", this.control).removeClass("control-focus");

  };

  // -----------------------------------------

  this.takeControl = function () {
    this.state = this.FOCUSED;
    this.setFirstFocus();
    $("body").trigger('controlEvent', ["takeControl", this.controlId]);
  };

  // -----------------------------------------

  this.leaveControl = function (direction) {

    //Main.log(this.controlId + " leave control: " + direction);
    this.state = this.NOTFOCUSED;
    this.clearFocus();
    $("body").trigger('controlEvent', ["leaveControl", null]);
    //$("body").trigger('keyPressed', [direction]);

  };

  // -----------------------------------------

  this.setFirstFocus = function () {

    $("#radioPlayer", this.control).addClass("control-focus");

    ////Main.log(this.control.parent().html());

  };

  // -----------------------------------------

}
